/**************************************************************************************************|
|* Copyright 2021 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|* - Generic Peripheral Library: A general and functional Interface for the specific Peripheral   *|
|* - Low Level Peripheral Access: Register-Bits Level access Macro, user must take care           *|
|*   of calling procedure and hardware constraints                                                *|
|* - Support Target: HY17M26                                                                      *|
|**************************************************************************************************/

/**************************************************************************************************|
|*                               Peripheral Register Bits field                                   *|
|**************************************************************************************************/
////	BIECN		//
#define	WR1Flag		     7
#define	WR1Flag_MSK		(1<<WR1Flag)
#define	WR1Flag_1	    (1<<WR1Flag)
#define	WR1Flag_0	    (0<<WR1Flag)

#define	BIEWR1		     2
#define	BIEWR1_MSK		(1<<BIEWR1)
#define	BIEWR1_WRITE	(1<<BIEWR1)
#define	BIEWR1_NORMAL	(0<<BIEWR1)

#define	BIEWR		     1
#define	BIEWR_MSK		(1<<BIEWR)
#define	BIEWR_WRITE	    (1<<BIEWR)
#define	BIEWR_NORMAL	(0<<BIEWR)

#define	BIERD		     0
#define	BIERD_MSK		(1<<BIERD)
#define	BIERD_READ	    (1<<BIERD)
#define	BIERD_NORMAL	(0<<BIERD)

////	BIE1CN		//
#define	BIE1ER		     5
#define	BIE1ER_MSK		(1<<BIE1ER)
#define	BIE1ER_ERASE	(1<<BIE1ER)
#define	BIE1ER_NORMAL	(0<<BIE1ER)

#define	BIE1WR		     1
#define	BIE1WR_MSK		(1<<BIE1WR)
#define	BIE1WR_WRITE	(1<<BIE1WR)
#define	BIE1WR_NORMAL	(0<<BIE1WR)

#define	BIE1RD		     0
#define	BIE1RD_MSK		(1<<BIE1RD)
#define	BIE1RD_READ	    (1<<BIE1RD)
#define	BIE1RD_NORMAL	(0<<BIE1RD)

////	BIE1ARH		//
#define	ENBIE1		     7
#define	ENBIE1_MSK		(1<<ENBIE1)
#define	ENBIE1_ERASE	(1<<ENBIE1)
#define	ENBIE1_NORMAL	(0<<ENBIE1)

/**************************************************************************************************|
|*                                      Function Level                                            *|
|**************************************************************************************************/
/*-------------------------------------------------------------------------------------------------|
|  Function-like Macro:                                                                            |
|    Register Bits field Configuration without function call overhead,                             |
|    user should take care of detail of h/w behavior and constrains.                               |
|-------------------------------------------------------------------------------------------------*/
//#define BIEKEY_Enable()		    (BIEKEY = 0x69)

#define BIE1_Enable()          (BIE1ARH |= ENBIE1_MSK)
#define	BIE1_Erase()		    (BIE1CN |= BIE1ER_MSK)   //Erase ALL 128 WORD

#define BIE1_DataWrite()       (BIE1CN |= BIE1WR_WRITE)
#define BIE1_IsWrite()         (BIE1CN & BIE1WR_WRITE)
#define	BIE1_DataRead()		   (BIE1CN |= BIE1RD_READ)
#define	BIE1_IsRead()		   (BIE1CN & BIE1RD_READ)





/*-------------------------------------------------------------------------------------------------|
|  Function call:                                                                                  |
|    For general and functional register access.                                                   |
|-------------------------------------------------------------------------------------------------*/
void BIE1_WriterData(unsigned char Addr,unsigned char DataH,unsigned char DataL);
unsigned int BIE1_ReadData(unsigned char Addr);

	