/**************************************************************************************************|
|* Copyright 2021 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|*                                                                                                *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Includes                                                                                      *|
|**************************************************************************************************/
#include <hy17m26sfr.h>
#include <BIE.h>

/**************************************************************************************************|
|*  Static Function                                                                               *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Generic Peripheral Library                                                                    *|
|**************************************************************************************************/

/*-------------------------------------------------------------------------------------------------|
|  Function: BIE_WriterData                                                                        |
|                                                                                                  |
|  Parameters:                                                                                     |
|         Addr      - [in]  0x00~0x7F                                                              |
|         DataH     - [in]  0x00~0xFF                                                              |
|         DataL     - [in]  0x00~0xFF                                                              |
|                                                                                                  |
|  Returns:                                                                                        |
|         None                                                                                     |
|                                                                                                  |
|  Description:                                                                                    |
|         This function is used to Write BIE                                                       |
|-------------------------------------------------------------------------------------------------*/
void BIE1_WriterData(unsigned char Addr,unsigned char DataH,unsigned char DataL) //Configure BIE write Addr & Data
{
   BIE1_Enable();
   BIE1ARL= Addr;
   BIE1DRH= DataH;
   BIE1DRL= DataL;
   BIE1_DataWrite();
   while(BIE1_IsWrite()!=0);
}

/*-------------------------------------------------------------------------------------------------|
|  Function: BIE1_ReadData                                                                         |
|                                                                                                  |
|  Parameters:                                                                                     |
|         Addr      - [in]  0x00~0x7F                                                              |
|                                                                                                  |
|  Returns:                                                                                        |
|         None                                                                                     |
|                                                                                                  |
|  Description:                                                                                    |
|         This function is used to Read BIE                                                        |
|-------------------------------------------------------------------------------------------------*/
unsigned int BIE1_ReadData(unsigned char Addr) //Configure BIE write Addr & Data
{
   unsigned int BIEData= 0;
   BIE1_Enable();
   BIE1ARL= Addr;
   BIE1_DataRead();
   while(BIE1_IsRead()!=0);
   BIEData= BIE1DRH<< 8;
   BIEData= BIEData | BIE1DRL;
   
   return BIEData;
}


/**************************************************************************************************|
|*  Static Functions                                                                              *|
|**************************************************************************************************/
