/**************************************************************************************************|
|* Copyright 2021 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|* - Generic Peripheral Library: A general and functional Interface for the specific Peripheral   *|
|* - Low Level Peripheral Access: Register-Bits Level access Macro, user must take care           *|
|*   of calling procedure and hardware constraints                                                *|
|* - Support Target: HY17M26                                                                 *|
|**************************************************************************************************/

/**************************************************************************************************|
|*                               Peripheral Register Bits field                                   *|
|**************************************************************************************************/

//// OSCCN0 //
#define OSCS                      6
#define OSCS_MSK                 (3 << OSCS)
//#define OSCS_XT                  (3 << OSCS)
#define OSCS_XT                  (2 << OSCS)
#define OSCS_LPO                 (1 << OSCS)
#define OSCS_HAO                 (0 << OSCS)

#define DHS                       4
#define DHS_MSK                  (3 << DHS)
#define DHS_HSCKDIV8             (3 << DHS)
#define DHS_HSCKDIV4             (2 << DHS)
#define DHS_HSCKDIV2             (1 << DHS)
#define DHS_HSCKDIV1             (0 << DHS)

#define DMS                       1
#define DMS_MSK                  (7 << DMS)
#define DMS_DHSCKDIV256          (7 << DMS)
#define DMS_DHSCKDIV128          (6 << DMS)
#define DMS_DHSCKDIV64           (5 << DMS)
#define DMS_DHSCKDIV32           (4 << DMS)
#define DMS_DHSCKDIV16           (3 << DMS)
#define DMS_DHSCKDIV8            (2 << DMS)
#define DMS_DHSCKDIV4            (1 << DMS)
#define DMS_DHSCKDIV2            (0 << DMS)

#define CPUS                      0
#define CPUS_MSK                 (1 << CPUS)
#define CPUS_DHSCK               (1 << CPUS)
#define CPUS_HSCK                (0 << CPUS)

//// OSCCN1 //
#define LCPS                      6
#define LCPS_MSK                 (1 << LCPS)
#define LCPS_XT                  (1 << LCPS)
#define LCPS_LPO                 (0 << LCPS)
 
#define DADC                      4
#define DADC_MSK                 (3 << DADC)
#define DADC_DHSCKDIV16          (3 << DADC)
#define DADC_DHSCKDIV8           (2 << DADC)
#define DADC_DHSCKDIV4           (1 << DADC)
#define DADC_DHSCKDIV2           (0 << DADC)

#define DTMB                      2
#define DTMB_MSK                 (3 << DTMB)
#define DTMB_TMBCKDIV8           (3 << DTMB)
#define DTMB_TMBCKDIV4           (2 << DTMB)
#define DTMB_TMBCKDIV2           (1 << DTMB)
#define DTMB_TMBCKDIV1           (0 << DTMB)

#define TMBS                      1
#define TMBS_MSK                 (1 << TMBS)
#define TMBS_LPCCK               (1 << TMBS)
#define TMBS_HSCK                (0 << TMBS)

//// OSCCN2 //
#define IDLEM                      6
#define IDLEM_MSK                 (3 << IDLEM)
#define IDLEM_HAOAuto             (3 << IDLEM)
#define IDLEM_HAODisable          (2 << IDLEM)
//#define IDLEM_Rev                 (1 << IDLEM)
#define IDLEM_Default             (0 << IDLEM)

#define ENXT                      5
#define ENXT_MSK                 (1 << ENXT)
#define ENXT_ENABLE              (1 << ENXT)
#define ENXT_DISABLE             (0 << ENXT)

#define XTS                       3
#define XTS_MSK                  (3 << XTS)
#define XTS_16M                  (3 << XTS)
#define XTS_2M                   (2 << XTS)
#define XTS_32768                (1 << XTS)
//#define XTS_32768                (0 << XTS)

#define HAOM                      1
#define HAOM_MSK                 (3 << HAOM)
#define HAOM_17510KHZ      	     (3 << HAOM)
#define HAOM_8755KHZ             (2 << HAOM)
#define HAOM_4147KHZ             (1 << HAOM)
#define HAOM_1843KHZ 	         (0 << HAOM)

#define ENHAO                     0
#define ENHAO_MSK                (1 << ENHAO)
#define ENHAO_ENABLE             (1 << ENHAO)
#define ENHAO_DISABLE            (0 << ENHAO)

//// OSCCN3 //
#define DTMB2                      2
#define DTMB2_MSK                 (3 << DTMB2)
#define DTMB2_TMBCKDIV8           (3 << DTMB2)
#define DTMB2_TMBCKDIV4           (2 << DTMB2)
#define DTMB2_TMBCKDIV2           (1 << DTMB2)
#define DTMB2_TMBCKDIV1           (0 << DTMB2)

#define TMB2S                       1
#define TMB2S_MSK                 (1 << TMB2S)
#define TMB2S_LPCCK               (1 << TMB2S)
#define TMB2S_HSCK                (0 << TMB2S)

//// TRIMCN0 //
#define TRIMOVL                     7
#define TRIMOVL_MSK               (1 << TRIMOVL)
#define TRIMOVL_1                 (1 << TRIMOVL)
#define TRIMOVL_0                 (0 << TRIMOVL)

#define TRIMLOCK                    6
#define TRIMLOCK_MSK              (1 << TRIMLOCK)
#define TRIMLOCK_1                (1 << TRIMLOCK)
#define TRIMLOCK_0                (0 << TRIMLOCK)

#define TRIMEN3                    2
#define TRIMEN3_MSK              (1 << TRIMEN3)
#define TRIMEN3_Enable           (1 << TRIMEN3)
#define TRIMEN3_Disable          (0 << TRIMEN3)

#define TRIMEN2                    1
#define TRIMEN2_MSK              (1 << TRIMEN2)
#define TRIMEN2_Enable           (1 << TRIMEN2)
#define TRIMEN2_Disable          (0 << TRIMEN2)

#define TRIMEN1                    0
#define TRIMEN1_MSK              (1 << TRIMEN1)
#define TRIMEN1_Enable           (1 << TRIMEN1)
#define TRIMEN1_Disable          (0 << TRIMEN1)


//// TRIMSRC //
#define XTCKDIV                    4
#define XTCKDIV_MSK             (15 << XTCKDIV)
//#define XTCKDIV_DIV           (15 << XTCKDIV)
//#define XTCKDIV_DIV           (14 << XTCKDIV)
//#define XTCKDIV_DIV           (13 << XTCKDIV)
//#define XTCKDIV_DIV           (12 << XTCKDIV)
//#define XTCKDIV_DIV           (11 << XTCKDIV)
#define XTCKDIV_DIV1024         (10<< XTCKDIV)
#define XTCKDIV_DIV512          (9 << XTCKDIV)
#define XTCKDIV_DIV256          (8 << XTCKDIV)
#define XTCKDIV_DIV128          (7 << XTCKDIV)
#define XTCKDIV_DIV64           (6 << XTCKDIV)
#define XTCKDIV_DIV32           (5 << XTCKDIV)
#define XTCKDIV_DIV16           (4 << XTCKDIV)
#define XTCKDIV_DIV8            (3 << XTCKDIV)
#define XTCKDIV_DIV4            (2 << XTCKDIV)
#define XTCKDIV_DIV2            (1 << XTCKDIV)
#define XTCKDIV_DIV1            (0 << XTCKDIV)

#define SRC                   0
#define SRC_MSK             (7 << SRC)
#define SRC_PT37            (7 << SRC)
#define SRC_PT36            (6 << SRC)
#define SRC_PT35            (5 << SRC)
#define SRC_PT34            (4 << SRC)
#define SRC_PT33            (3 << SRC)
#define SRC_PT32            (2 << SRC)
#define SRC_PT31            (1 << SRC)
#define SRC_PT30            (0 << SRC)

#define TrimMode_MSK              7

/**************************************************************************************************|
|*                                      Function Level                                            *|
|**************************************************************************************************/

/*-------------------------------------------------------------------------------------------------|
|  Function-like Macro:                                                                            |
|    Register Bits field Configuration without function call overhead,                             |
|    user should take care of detail of h/w behavior and constrains.                               |
|-------------------------------------------------------------------------------------------------*/
//CLK Config function for Peripherals were placed in each peripheral module individually
//CLK Config for MCU(System Clock)were declared/defined below

// Ext Oscillator //
#define CLK_XTEnable()                 (OSCCN2 |= ENXT_ENABLE)
#define CLK_XTDisable()                (OSCCN2 &= (~ENXT_MSK)) 
#define CLK_XTSelect(XTSel)            (OSCCN2 = ((OSCCN2 & (~XTS_MSK)) | XTSel))
// HAO Oscillator //
#define CLK_HAOEnable()                (OSCCN2 |= ENHAO_ENABLE)
#define CLK_HAODisable()               (OSCCN2 &= (~ENHAO_MSK)) 
#define CLK_HAOSelect(HAOSel)          (OSCCN2 = ((OSCCN2 & (~HAOM_MSK)) | HAOSel))

// System Clock Selection //
#define CLK_LPCCKSelect(LPCCKSel)      (OSCCN1 = ((OSCCN1 & (~LCPS_MSK)) | LPCCKSel))

// HAO setting at Idle mode //
#define CLK_IDLE_HAOSet(haomode)       (OSCCN2 = ((OSCCN2 & (~IDLEM_MSK)) | haomode))

// ADC CLK Selection //
//#define ADC_CLK_DivSelect(DADCSel)     (OSCCN1 = (OSCCN1 & (~DADC_MSK)) | DADCSel)  
#define CLK_ADCCKDivSelect(DADCSel)     (OSCCN1 = ((OSCCN1 & (~DADC_MSK)) | DADCSel))


// TMB CLK Selection //
//#define TB1_CKSelect(TMBCKSel)         (OSCCN1 = ((OSCCN1 & (~TMBS_MSK)) | TMBCKSel))
//#define TB1_CKDivSelect(TMBCKDivSel)   (OSCCN1 = ((OSCCN1 & (~DTMB_MSK)) | TMBCKDivSel))
#define CLK_TMBCKDivSelect(TMBCKDivSel)   (OSCCN1 = ((OSCCN1 & (~DTMB_MSK)) | TMBCKDivSel))
#define CLK_TMBCKSelect(TMBCKSel)         (OSCCN1 = ((OSCCN1 & (~TMBS_MSK)) | TMBCKSel))
//#define TB2_CKSelect(TMB2CKSel)         (OSCCN3 = ((OSCCN3 & (~TMB2S_MSK)) | TMB2CKSel))
//#define TB2_CKDivSelect(TMB2CKDivSel)   (OSCCN3 = ((OSCCN3 & (~DTMB2_MSK)) | TMB2CKDivSel))
#define CLK_TMB2CKDivSelect(TMB2CKDivSel)   (OSCCN3 = ((OSCCN3 & (~DTMB2_MSK)) | TMB2CKDivSel))
#define CLK_TMB2CKSelect(TMB2CKSel)         (OSCCN3 = ((OSCCN3 & (~TMB2S_MSK)) | TMB2CKSel))

// System Clock Selection //
#define CLK_OSCSelect(OSCSel)          (OSCCN0 = ((OSCCN0 & (~OSCS_MSK)) | OSCSel))
#define CLK_DHSCKSelect(DHSCKSel)      (OSCCN0 = ((OSCCN0 & (~DHS_MSK)) | DHSCKSel))
#define CLK_DMSCKSelect(DMSCKSel)      (OSCCN0 = ((OSCCN0 & (~DMS_MSK)) | DMSCKSel))
#define CLK_CPUCKSelect(CPUCKSel)      (OSCCN0 = ((OSCCN0 & (~CPUS_MSK)) | CPUCKSel))
#define CLK_CPUCK_Sel(DHSdiv,CPUCKsel) (OSCCN0 = (OSCCN0 &(~(DHS_MSK | CPUS_MSK))) | DHSdiv | CPUCKsel)

// HAO Trim  //
#define HAO_TrimCounter_Read()          (TRIMCN0 & TRIMOVL_MSK)
#define HAO_TrimValue_Read()            (TRIMCN0 & TRIMLOCK_MSK)
#define HAO_TrimModeSelect(trimsel)     (TRIMCN0 = ((TRIMCN0 & (~TrimMode_MSK)) | trimsel))
#define HAO_TrimMode1_Read()            (TRIMCN0 & TRIMEN1_MSK)
#define HAO_TrimMode2_Read()            (TRIMCN0 & TRIMEN2_MSK)
#define HAO_TrimMode3_Read()            (TRIMCN0 & TRIMEN3_MSK)
#define HAO_TrimPinSelect(Pinsel)       (TRIMSRC = ((TRIMSRC & (~SRC_MSK)) | Pinsel))



/*-------------------------------------------------------------------------------------------------|
|  Function call:                                                                                  |
|    For general and functional register access.                                                   |
|-------------------------------------------------------------------------------------------------*/
void CLK_CPUCKOpen(unsigned char haom,				//HAO Frequence Selection
                                       unsigned char oscs,       		   //HS_CK Selection 
                                       unsigned char dhsck,			     //DHS_CK Selection                                          
                                       unsigned char cpuck);               //CPU_CK Source Selection 
void CLK_GPIO_OpenXTInput(void);
unsigned char HAO_TrimMode1(unsigned int trimcnt);  //TRIMCNT[9:0] Value
unsigned char HAO_TrimMode2(unsigned int trimcnt,   //TRIMCNT[9:0] Value
                            unsigned int trimIO);   //Input Pin Selection
unsigned char HAO_TrimMode3(unsigned int trimcnt);  //TRIMCNT[9:0] Value