/**************************************************************************************************|
|* Copyright 2021 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|* - Generic Peripheral Library: A general and functional Interface for the specific Peripheral   *|
|* - Low Level Peripheral Access: Register-Bits Level access Macro, user must take care           *|
|*   of calling procedure and hardware constraints                                                *|
|* - Support Target: HY17M Series                                                                 *|
|**************************************************************************************************/
#include <INT.h>
/**************************************************************************************************|
|*                               Peripheral Register Bits field                                   *|
|**************************************************************************************************/
//// PT1 //
#define PT10                      0
#define PT10_MSK                 (1 << PT10)
#define PT10_H                   (1 << PT10)
#define PT10_L                   (0 << PT10)
#define PT11                      1
#define PT11_MSK                 (1 << PT11)
#define PT11_H                   (1 << PT11)
#define PT11_L                   (0 << PT11)
#define PT12                      2
#define PT12_MSK                 (1 << PT12)
#define PT12_H                   (1 << PT12)
#define PT12_L                   (0 << PT12)
#define PT13                      3
#define PT13_MSK                 (1 << PT13)
#define PT13_H                   (1 << PT13)
#define PT13_L                   (0 << PT13)
#define PT14                      4
#define PT14_MSK                 (1 << PT14)
#define PT14_H                   (1 << PT14)
#define PT14_L                   (0 << PT14)
#define PT15                      5
#define PT15_MSK                 (1 << PT15)
#define PT15_H                   (1 << PT15)
#define PT15_L                   (0 << PT15)
#define PT16                      6
#define PT16_MSK                 (1 << PT16)
#define PT16_H                   (1 << PT16)
#define PT16_L                   (0 << PT16)

//// PT1IN //
#define IN10                      0
#define IN10_MSK                 (1 << IN10)
#define IN10_H                   (1 << IN10)
#define IN10_L                   (0 << IN10)
#define IN11                      1
#define IN11_MSK                 (1 << IN11)
#define IN11_H                   (1 << IN11)
#define IN11_L                   (0 << IN11)
#define IN12                      2
#define IN12_MSK                 (1 << IN12)
#define IN12_H                   (1 << IN12)
#define IN12_L                   (0 << IN12)
#define IN13                      3
#define IN13_MSK                 (1 << IN13)
#define IN13_H                   (1 << IN13)
#define IN13_L                   (0 << IN13)
#define IN14                      4
#define IN14_MSK                 (1 << IN14)
#define IN14_H                   (1 << IN14)
#define IN14_L                   (0 << IN14)
#define IN15                      5
#define IN15_MSK                 (1 << IN15)
#define IN15_H                   (1 << IN15)
#define IN15_L                   (0 << IN15)
#define IN16                      6
#define IN16_MSK                 (1 << IN16)
#define IN16_H                   (1 << IN16)
#define IN16_L                   (0 << IN16)

//// TRISC1 //
#define TC10                      0
#define TC10_MSK                 (1 << TC10)
#define TC10_H                   (1 << TC10)
#define TC10_L                   (0 << TC10)
#define TC11                      1
#define TC11_MSK                 (1 << TC11)
#define TC11_H                   (1 << TC11)
#define TC11_L                   (0 << TC11)
#define TC12                      2
#define TC12_MSK                 (1 << TC12)
#define TC12_H                   (1 << TC12)
#define TC12_L                   (0 << TC12)
#define TC13                      3
#define TC13_MSK                 (1 << TC13)
#define TC13_H                   (1 << TC13)
#define TC13_L                   (0 << TC13)
#define TC14                      4
#define TC14_MSK                 (1 << TC14)
#define TC14_H                   (1 << TC14)
#define TC14_L                   (0 << TC14)
#define TC15                      5
#define TC15_MSK                 (1 << TC15)
#define TC15_H                   (1 << TC15)
#define TC15_L                   (0 << TC15)
#define TC16                      6
#define TC16_MSK                 (1 << TC16)
#define TC16_H                   (1 << TC16)
#define TC16_L                   (0 << TC16)

//// PT1PU //
#define PU10                      0
#define PU10_MSK                 (1 << PU10)
#define PU10_H                   (1 << PU10)
#define PU10_L                   (0 << PU10)
#define PU11                      1
#define PU11_MSK                 (1 << PU11)
#define PU11_H                   (1 << PU11)
#define PU11_L                   (0 << PU11)
#define PU12                      2
#define PU12_MSK                 (1 << PU12)
#define PU12_H                   (1 << PU12)
#define PU12_L                   (0 << PU12)
#define PU13                      3
#define PU13_MSK                 (1 << PU13)
#define PU13_H                   (1 << PU13)
#define PU13_L                   (0 << PU13)
#define PU14                      4
#define PU14_MSK                 (1 << PU14)
#define PU14_H                   (1 << PU14)
#define PU14_L                   (0 << PU14)
#define PU15                      5
#define PU15_MSK                 (1 << PU15)
#define PU15_H                   (1 << PU15)
#define PU15_L                   (0 << PU15)
#define PU16                      6
#define PU16_MSK                 (1 << PU16)
#define PU16_H                   (1 << PU16)
#define PU16_L                   (0 << PU16)

//// PT1DA //
#define DA10                      0
#define DA10_MSK                 (1 << DA10)
#define DA10_H                   (1 << DA10)
#define DA10_L                   (0 << DA10)
#define DA11                      1
#define DA11_MSK                 (1 << DA11)
#define DA11_H                   (1 << DA11)
#define DA11_L                   (0 << DA11)
#define DA12                      2
#define DA12_MSK                 (1 << DA12)
#define DA12_H                   (1 << DA12)
#define DA12_L                   (0 << DA12)
#define DA13                      3
#define DA13_MSK                 (1 << DA13)
#define DA13_H                   (1 << DA13)
#define DA13_L                   (0 << DA13)
//#define DA14                      4
//#define DA14_MSK                 (1 << DA14)
//#define DA14_H                   (1 << DA14)
//#define DA14_L                   (0 << DA14)
//#define DA15                      5
//#define DA15_MSK                 (1 << DA15)
//#define DA15_H                   (1 << DA15)
//#define DA15_L                   (0 << DA15)
//#define DA16                      6
//#define DA16_MSK                 (1 << DA16)
//#define DA16_H                   (1 << DA16)
//#define DA16_L                   (0 << DA16)

//// PT2 //
#define PT20                      0
#define PT20_MSK                 (1 << PT20)
#define PT20_H                   (1 << PT20)
#define PT20_L                   (0 << PT20)
#define PT21                      1
#define PT21_MSK                 (1 << PT21)
#define PT21_H                   (1 << PT21)
#define PT21_L                   (0 << PT21)
#define PT22                      2
#define PT22_MSK                 (1 << PT22)
#define PT22_H                   (1 << PT22)
#define PT22_L                   (0 << PT22)
#define PT23                      3
#define PT23_MSK                 (1 << PT23)
#define PT23_H                   (1 << PT23)
#define PT23_L                   (0 << PT23)
#define PT24                      4
#define PT24_MSK                 (1 << PT24)
#define PT24_H                   (1 << PT24)
#define PT24_L                   (0 << PT24)
#define PT25                      5
#define PT25_MSK                 (1 << PT25)
#define PT25_H                   (1 << PT25)
#define PT25_L                   (0 << PT25)
#define PT26                      6
#define PT26_MSK                 (1 << PT26)
#define PT26_H                   (1 << PT26)
#define PT26_L                   (0 << PT26)
#define PT27                      7
#define PT27_MSK                 (1 << PT27)
#define PT27_H                   (1 << PT27)
#define PT27_L                   (0 << PT27)

//// PT2IN //
#define IN20                      0
#define IN20_MSK                 (1 << IN20)
#define IN20_H                   (1 << IN20)
#define IN20_L                   (0 << IN20)
#define IN21                      1
#define IN21_MSK                 (1 << IN21)
#define IN21_H                   (1 << IN21)
#define IN21_L                   (0 << IN21)
#define IN22                      2
#define IN22_MSK                 (1 << IN22)
#define IN22_H                   (1 << IN22)
#define IN22_L                   (0 << IN22)
#define IN23                      3
#define IN23_MSK                 (1 << IN23)
#define IN23_H                   (1 << IN23)
#define IN23_L                   (0 << IN23)
#define IN24                      4
#define IN24_MSK                 (1 << IN24)
#define IN24_H                   (1 << IN24)
#define IN24_L                   (0 << IN24)
#define IN25                      5
#define IN25_MSK                 (1 << IN25)
#define IN25_H                   (1 << IN25)
#define IN25_L                   (0 << IN25)
#define IN26                      6
#define IN26_MSK                 (1 << IN26)
#define IN26_H                   (1 << IN26)
#define IN26_L                   (0 << IN26)
#define IN27                      7
#define IN27_MSK                 (1 << IN27)
#define IN27_H                   (1 << IN27)
#define IN27_L                   (0 << IN27)

//// TRISC2 //
#define TC20                      0
#define TC20_MSK                 (1 << TC20)
#define TC20_H                   (1 << TC20)
#define TC20_L                   (0 << TC20)
#define TC21                      1
#define TC21_MSK                 (1 << TC21)
#define TC21_H                   (1 << TC21)
#define TC21_L                   (0 << TC21)
#define TC22                      2
#define TC22_MSK                 (1 << TC22)
#define TC22_H                   (1 << TC22)
#define TC22_L                   (0 << TC22)
#define TC23                      3
#define TC23_MSK                 (1 << TC23)
#define TC23_H                   (1 << TC23)
#define TC23_L                   (0 << TC23)
#define TC24                      4
#define TC24_MSK                 (1 << TC24)
#define TC24_H                   (1 << TC24)
#define TC24_L                   (0 << TC24)
#define TC25                      5
#define TC25_MSK                 (1 << TC25)
#define TC25_H                   (1 << TC25)
#define TC25_L                   (0 << TC25)
#define TC26                      6
#define TC26_MSK                 (1 << TC26)
#define TC26_H                   (1 << TC26)
#define TC26_L                   (0 << TC26)
#define TC27                      7
#define TC27_MSK                 (1 << TC27)
#define TC27_H                   (1 << TC27)
#define TC27_L                   (0 << TC27)

//// PT2DA //
//#define DA20                      0
//#define DA20_MSK                 (1 << DA20)
//#define DA20_H                   (1 << DA20)
//#define DA20_L                   (0 << DA20)
//#define DA21                      2
//#define DA21_MSK                 (1 << DA21)
//#define DA21_H                   (1 << DA21)
//#define DA21_L                   (0 << DA21)
//#define DA22                      2
//#define DA22_MSK                 (1 << DA22)
//#define DA22_H                   (1 << DA22)
//#define DA22_L                   (0 << DA22)
#define DA23                      3
#define DA23_MSK                 (1 << DA23)
#define DA23_H                   (1 << DA23)
#define DA23_L                   (0 << DA23)
#define DA24                      4
#define DA24_MSK                 (1 << DA24)
#define DA24_H                   (1 << DA24)
#define DA24_L                   (0 << DA24)
#define DA25                      5
#define DA25_MSK                 (1 << DA25)
#define DA25_H                   (1 << DA25)
#define DA25_L                   (0 << DA25)
#define DA26                      6
#define DA26_MSK                 (1 << DA26)
#define DA26_H                   (1 << DA26)
#define DA26_L                   (0 << DA26)
#define DA27                      7
#define DA27_MSK                 (1 << DA2)
#define DA27_H                   (1 << DA27)
#define DA27_L                   (0 << DA27)

//// PT2PU //
#define PU20                      0
#define PU20_MSK                 (1 << PU20)
#define PU20_H                   (1 << PU20)
#define PU20_L                   (0 << PU20)
#define PU21                      1
#define PU21_MSK                 (1 << PU21)
#define PU21_H                   (1 << PU21)
#define PU21_L                   (0 << PU21)
#define PU22                      2
#define PU22_MSK                 (1 << PU22)
#define PU22_H                   (1 << PU22)
#define PU22_L                   (0 << PU22)
#define PU23                      3
#define PU23_MSK                 (1 << PU23)
#define PU23_H                   (1 << PU23)
#define PU23_L                   (0 << PU23)
#define PU24                      4
#define PU24_MSK                 (1 << PU24)
#define PU24_H                   (1 << PU24)
#define PU24_L                   (0 << PU24)
#define PU25                      5
#define PU25_MSK                 (1 << PU25)
#define PU25_H                   (1 << PU25)
#define PU25_L                   (0 << PU25)
#define PU26                      6
#define PU26_MSK                 (1 << PU26)
#define PU26_H                   (1 << PU26)
#define PU26_L                   (0 << PU26)
#define PU27                      7
#define PU27_MSK                 (1 << PU27)
#define PU27_H                   (1 << PU27)
#define PU27_L                   (0 << PU27)

//// PT3 //
#define PT30                      0
#define PT30_MSK                 (1 << PT30)
#define PT30_H                   (1 << PT30)
#define PT30_L                   (0 << PT30)
#define PT31                      1
#define PT31_MSK                 (1 << PT31)
#define PT31_H                   (1 << PT31)
#define PT31_L                   (0 << PT31)
#define PT32                      2
#define PT32_MSK                 (1 << PT32)
#define PT32_H                   (1 << PT32)
#define PT32_L                   (0 << PT32)
#define PT33                      3
#define PT33_MSK                 (1 << PT33)
#define PT33_H                   (1 << PT33)
#define PT33_L                   (0 << PT33)
#define PT34                      4
#define PT34_MSK                 (1 << PT34)
#define PT34_H                   (1 << PT34)
#define PT34_L                   (0 << PT34)
#define PT35                      5
#define PT35_MSK                 (1 << PT35)
#define PT35_H                   (1 << PT35)
#define PT35_L                   (0 << PT35)
#define PT36                      6
#define PT36_MSK                 (1 << PT36)
#define PT36_H                   (1 << PT36)
#define PT36_L                   (0 << PT36)
#define PT37                      7
#define PT37_MSK                 (1 << PT37)
#define PT37_H                   (1 << PT37)
#define PT37_L                   (0 << PT37)

//// PT3IN //
#define IN30                      0
#define IN30_MSK                 (1 << IN30)
#define IN30_H                   (1 << IN30)
#define IN30_L                   (0 << IN30)
#define IN31                      1
#define IN31_MSK                 (1 << IN31)
#define IN31_H                   (1 << IN31)
#define IN31_L                   (0 << IN31)
#define IN32                      2
#define IN32_MSK                 (1 << IN32)
#define IN32_H                   (1 << IN32)
#define IN32_L                   (0 << IN32)
#define IN33                      3
#define IN33_MSK                 (1 << IN33)
#define IN33_H                   (1 << IN33)
#define IN33_L                   (0 << IN33)
#define IN34                      4
#define IN34_MSK                 (1 << IN34)
#define IN34_H                   (1 << IN34)
#define IN34_L                   (0 << IN34)
#define IN35                      5
#define IN35_MSK                 (1 << IN35)
#define IN35_H                   (1 << IN35)
#define IN35_L                   (0 << IN35)
#define IN36                      6
#define IN36_MSK                 (1 << IN36)
#define IN36_H                   (1 << IN36)
#define IN36_L                   (0 << IN36)
#define IN37                      7
#define IN37_MSK                 (1 << IN37)
#define IN37_H                   (1 << IN37)
#define IN37_L                   (0 << IN37)

//// TRISC3 //
#define TC30                      0
#define TC30_MSK                 (1 << TC30)
#define TC30_H                   (1 << TC30)
#define TC30_L                   (0 << TC30)
#define TC31                      1
#define TC31_MSK                 (1 << TC31)
#define TC31_H                   (1 << TC31)
#define TC31_L                   (0 << TC31)
#define TC32                      2
#define TC32_MSK                 (1 << TC32)
#define TC32_H                   (1 << TC32)
#define TC32_L                   (0 << TC32)
#define TC33                      3
#define TC33_MSK                 (1 << TC33)
#define TC33_H                   (1 << TC33)
#define TC33_L                   (0 << TC33)
#define TC34                      4
#define TC34_MSK                 (1 << TC34)
#define TC34_H                   (1 << TC34)
#define TC34_L                   (0 << TC34)
#define TC35                      5
#define TC35_MSK                 (1 << TC35)
#define TC35_H                   (1 << TC35)
#define TC35_L                   (0 << TC35)
#define TC36                      6
#define TC36_MSK                 (1 << TC36)
#define TC36_H                   (1 << TC36)
#define TC36_L                   (0 << TC36)
#define TC37                      7
#define TC37_MSK                 (1 << TC37)
#define TC37_H                   (1 << TC37)
#define TC37_L                   (0 << TC37)

//// PT3PU //
#define PU30                      0
#define PU30_MSK                 (1 << PU30)
#define PU30_H                   (1 << PU30)
#define PU30_L                   (0 << PU30)
#define PU31                      1
#define PU31_MSK                 (1 << PU31)
#define PU31_H                   (1 << PU31)
#define PU31_L                   (0 << PU31)
#define PU32                      2
#define PU32_MSK                 (1 << PU32)
#define PU32_H                   (1 << PU32)
#define PU32_L                   (0 << PU32)
#define PU33                      3
#define PU33_MSK                 (1 << PU33)
#define PU33_H                   (1 << PU33)
#define PU33_L                   (0 << PU33)
#define PU34                      4
#define PU34_MSK                 (1 << PU34)
#define PU34_H                   (1 << PU34)
#define PU34_L                   (0 << PU34)
#define PU35                      5
#define PU35_MSK                 (1 << PU35)
#define PU35_H                   (1 << PU35)
#define PU35_L                   (0 << PU35)
#define PU36                      6
#define PU36_MSK                 (1 << PU36)
#define PU36_H                   (1 << PU36)
#define PU36_L                   (0 << PU36)
#define PU37                      7
#define PU37_MSK                 (1 << PU37)
#define PU37_H                   (1 << PU37)
#define PU37_L                   (0 << PU37)

//// PT3DA //
//#define DA30                      0
//#define DA30_MSK                 (1 << DA30)
//#define DA30_H                   (1 << DA30)
//#define DA30_L                   (0 << DA30)
#define DA31                      1
#define DA31_MSK                 (1 << DA31)
#define DA31_H                   (1 << DA31)
#define DA31_L                   (0 << DA31)
#define DA32                      2
#define DA32_MSK                 (1 << DA32)
#define DA32_H                   (1 << DA32)
#define DA32_L                   (0 << DA32)
#define DA33                      3
#define DA33_MSK                 (1 << DA33)
#define DA33_H                   (1 << DA33)
#define DA33_L                   (0 << DA33)
#define DA34                      4
#define DA34_MSK                 (1 << DA34)
#define DA34_H                   (1 << DA34)
#define DA34_L                   (0 << DA34)
#define DA35                      5
#define DA35_MSK                 (1 << DA35)
#define DA35_H                   (1 << DA35)
#define DA35_L                   (0 << DA35)
#define DA36                      6
#define DA36_MSK                 (1 << DA36)
#define DA36_H                   (1 << DA36)
#define DA36_L                   (0 << DA36)
#define DA37                      7
#define DA37_MSK                 (1 << DA37)
#define DA37_H                   (1 << DA37)
#define DA37_L                   (0 << DA37)

//// GPort0 //
#define GTBI2                     6
#define GTBI2_MSK                (3 << GTBI2)
#define GTBI2_PT36               (3 << GTBI2)
#define GTBI2_PT24               (2 << GTBI2)
#define GTBI2_PT12               (1 << GTBI2)
#define GTBI2_OFF                (0 << GTBI2)

#define GTBI1                     3
#define GTBI1_MSK                (7 << GTBI1)
//#define GTBI1_Rev              (7 << GTBI1)
//#define GTBI1_Rev              (6 << GTBI1)
//#define GTBI1_Rev              (5 << GTBI1)
#define GTBI1_PT27               (4 << GTBI1)
#define GTBI1_PT16               (3 << GTBI1)
#define GTBI1_PT37               (2 << GTBI1)
#define GTBI1_PT30               (1 << GTBI1)
#define GTBI1_OFF                (0 << GTBI1)

#define GTBI0                     0
#define GTBI0_MSK                (7 << GTBI0)
//#define GTBI0_Rev              (7 << GTBI0)
//#define GTBI0_Rev              (6 << GTBI0)
//#define GTBI0_Rev              (5 << GTBI0)
#define GTBI0_PT20               (4 << GTBI0)
#define GTBI0_PT11               (3 << GTBI0)
#define GTBI0_PT31               (2 << GTBI0)
#define GTBI0_PT10               (1 << GTBI0)
#define GTBI0_OFF                (0 << GTBI0)


//// GPort1 //
#define GBuz                     5
#define GBuz_MSK                (7 << GBuz)
//#define GBuz_Rev                (7 << GBuz)
//#define GBuz_Rev                (6 << GBuz)
#define GBuz_PT21               (5 << GBuz)
#define GBuz_PT14               (4 << GBuz)
#define GBuz_PT32               (3 << GBuz)
#define GBuz_PT31               (2 << GBuz)
#define GBuz_PT30               (1 << GBuz)
#define GBuz_OFF                (0 << GBuz)

#define GTCI2                     2
#define GTCI2_MSK                (3 << GTCI2)
#define GTCI2_PT35               (3 << GTCI2)
#define GTCI2_PT23               (2 << GTCI2)
#define GTCI2_PT14               (1 << GTCI2)
#define GTCI2_OFF                (0 << GTCI2)

#define GTCI1                     0
#define GTCI1_MSK                (3 << GTCI1)
#define GTCI1_PT34               (3 << GTCI1)
#define GTCI1_PT22               (2 << GTCI1)
#define GTCI1_PT13               (1 << GTCI1)
#define GTCI1_OFF                (0 << GTCI1)

//// GPort2 //
#define GPWM1                     4
#define GPWM1_MSK                (7 << GPWM1)
//#define GPWM1_Rev              (7 << GPWM1)
//#define GPWM1_Rev              (6 << GPWM1)
//#define GPWM1_Rev              (5 << GPWM1)
#define GPWM1_PT37               (4 << GPWM1)
#define GPWM1_PT35               (3 << GPWM1)
#define GPWM1_PT33               (2 << GPWM1)
#define GPWM1_PT31               (1 << GPWM1)
#define GPWM1_OFF                (0 << GPWM1)

#define GPWM0                     0
#define GPWM0_MSK                (7 << GPWM0)
//#define GPWM0_Rev              (7 << GPWM0)
//#define GPWM0_Rev              (6 << GPWM0)
//#define GPWM0_Rev              (5 << GPWM0)
#define GPWM0_PT36               (4 << GPWM0)
#define GPWM0_PT34               (3 << GPWM0)
#define GPWM0_PT32               (2 << GPWM0)
#define GPWM0_PT30               (1 << GPWM0)
#define GPWM0_OFF                (0 << GPWM0)

//// GPort3 //
#define GPWM3                     4
#define GPWM3_MSK                (7 << GPWM3)
//#define GPWM3_Rev              (7 << GPWM3)
//#define GPWM3_Rev              (6 << GPWM3)
//#define GPWM3_Rev              (5 << GPWM3)
#define GPWM3_PT23               (4 << GPWM3)
#define GPWM3_PT21               (3 << GPWM3)
#define GPWM3_PT14               (2 << GPWM3)
#define GPWM3_PT12               (1 << GPWM3)
#define GPWM3_OFF                (0 << GPWM3)

#define GPWM2                     0
#define GPWM2_MSK                (7 << GPWM2)
//#define GPWM2_Rev              (7 << GPWM2)
//#define GPWM2_Rev              (6 << GPWM2)
//#define GPWM2_Rev              (5 << GPWM2)
#define GPWM2_PT22               (4 << GPWM2)
#define GPWM2_PT20               (3 << GPWM2)
#define GPWM2_PT13               (2 << GPWM2)
#define GPWM2_PT11               (1 << GPWM2)
#define GPWM2_OFF                (0 << GPWM2)

//// GPort4 //
#define GSCL2                     5
#define GSCL2_MSK                (7 << GSCL2)
//#define GSCL2_Rev              (7 << GSCL2)
//#define GSCL2_Rev              (6 << GSCL2)
//#define GSCL2_Rev              (5 << GSCL2)
#define GSCL2_PT27               (4 << GSCL2)
#define GSCL2_PT23               (3 << GSCL2)
#define GSCL2_PT16               (2 << GSCL2)
#define GSCL2_PT12               (1 << GSCL2)
#define GSCL2_OFF                (0 << GSCL2)

#define GSCL                      2
#define GSCL_MSK                 (7 << GSCL)
//#define GSCL_Rev               (7 << GSCL)
//#define GSCL_Rev               (6 << GSCL)
//#define GSCL_Rev               (5 << GSCL)
#define GSCL_PT37                (4 << GSCL)
#define GSCL_PT35                (3 << GSCL)
#define GSCL_PT33                (2 << GSCL)
#define GSCL_PT31                (1 << GSCL)
#define GSCL_OFF                 (0 << GSCL)

#define GSPI                      0
#define GSPI_MSK                 (3 << GSPI)
#define GSPI_PT31                (3 << GSPI)
#define GSPI_PT25                (2 << GSPI)
#define GSPI_PT11                (1 << GSPI)
#define GSPI_OFF                 (0 << GSPI)

//// GPort5 //
#define GTX2                      4
#define GTX2_MSK                 (7 << GTX2)
//#define GTX2_Rev               (7 << GTX2)
//#define GTX2_Rev               (6 << GTX2)
//#define GTX2_Rev               (5 << GTX2)
#define GTX2_PT26                (4 << GTX2)
#define GTX2_PT22                (3 << GTX2)
#define GTX2_PT15                (2 << GTX2)
#define GTX2_PT11                (1 << GTX2)
#define GTX2_OFF                 (0 << GTX2)

#define GTX                       0
#define GTX_MSK                  (7 << GTX)
//#define GTX_Rev                (7 << GTX)
//#define GTX_Rev                (6 << GTX)
//#define GTX_Rev                (5 << GTX)
#define GTX_PT36                 (4 << GTX)
#define GTX_PT34                 (3 << GTX)
#define GTX_PT32                 (2 << GTX)
#define GTX_PT30                 (1 << GTX)
#define GTX_OFF                  (0 << GTX)

/**************************************************************************************************|
|*                                      Function Level                                            *|
|**************************************************************************************************/

/*-------------------------------------------------------------------------------------------------|
|  Function-like Macro:                                                                            |
|    Register Bits field Configuration without function call overhead,                             |
|    user should take care of detail of h/w behavior and constrains.                               |
|-------------------------------------------------------------------------------------------------*/
// Peripherals/GPIO Multiplexing Config for Peripherals were placed in each peripheral module
// individually GPIO Config were declared/defined below

// PT1.x // x=0~6
#define GPIO_PT1InputMode(BitSet)            (TRISC1 &= ~(1 << BitSet))
#define GPIO_PT1OutputMode(BitSet)           (TRISC1 |= (1 << BitSet))

#define GPIO_PT1OutputHigh(BitSet)           (PT1 |= (1 << BitSet))
#define GPIO_PT1OutputLow(BitSet)            (PT1 &= ~(1 << BitSet)) 

#define GPIO_PT1DigitalEnable(BitSet)          (PT1IN |= (1 << BitSet))
#define GPIO_PT1DigitalDisable(BitSet)         (PT1IN &= ~(1 << BitSet))

#define GPIO_PT1SETPU(BitSet)                (PT1PU |= (1 << BitSet))
#define GPIO_PT1CLRPU(BitSet)                (PT1PU &= ~ (1 << BitSet))
#define GPIO_PT1SETPUAll()                   (PT1PU = 0xff)

#define GPIO_PT1SETDA(BitSet)                (PT1DA |= (1 << BitSet))   //PT1.0~1.3
#define GPIO_PT1CLRDA(BitSet)                (PT1DA &= ~ (1 << BitSet)) //PT1.0~1.3

#define GPIO_PT1GET(BitSet)                  (PT1 & (1 << BitSet))
#define GPIO_PT1SET(BitSet)                  (PT1 |=  (1 << BitSet))
#define GPIO_PT1CLR(BitSet)                  (PT1 &= ~(1 << BitSet))

// PT2.x // x=0~7
#define GPIO_PT2InputMode(BitSet)            (TRISC2 &= ~(1 << BitSet))
#define GPIO_PT2OutputMode(BitSet)           (TRISC2 |=(1 << BitSet))

#define GPIO_PT2OutputHigh(BitSet)           (PT2 |= (1 << BitSet))
#define GPIO_PT2OutputLow(BitSet)            (PT2 &= ~(1 << BitSet))

#define GPIO_PT2DigitalEnable(BitSet)          (PT2IN |= (1 << BitSet))
#define GPIO_PT2DigitalDisable(BitSet)         (PT2IN &= ~(1 << BitSet))

#define GPIO_PT2SETPU(BitSet)                (PT2PU |= (1 << BitSet))
#define GPIO_PT2CLRPU(BitSet)                (PT2PU &= ~(1 << BitSet))
#define GPIO_PT2SETPUAll()                   (PT2PU = 0xff)

#define GPIO_PT2SETDA(BitSet)              (PT2DA |=(1 << BitSet))    //PT2.3~2.7
#define GPIO_PT2CLRDA(BitSet)              (PT2DA &= ~ (1 << BitSet)) //PT2.3~2.7

#define GPIO_PT2GET(BitSet)                  (PT2 & (1 << BitSet))
#define GPIO_PT2SET(BitSet)                  (PT2 |= (1 << BitSet))
#define GPIO_PT2CLR(BitSet)                  (PT2 &= ~(1 << BitSet))


// PT3.x // x=0~7
#define GPIO_PT3InputMode(BitSet)            (TRISC3 &= ~(1 << BitSet))
#define GPIO_PT3OutputMode(BitSet)           (TRISC3 |= (1 << BitSet))

#define GPIO_PT3OutputHigh(BitSet)           (PT3 |= (1 << BitSet))
#define GPIO_PT3OutputLow(BitSet)            (PT3 &= ~(1 << BitSet))

#define GPIO_PT3DigitalEnable(BitSet)        (PT3IN |=  (1 << BitSet))
#define GPIO_PT3DigitalDisable(BitSet)       (PT3IN &= ~(1 << BitSet))

#define GPIO_PT3SETPU(BitSet)                (PT3PU |=  (1 << BitSet))
#define GPIO_PT3CLRPU(BitSet)                (PT3PU &= ~(1 << BitSet))
#define GPIO_PT3SETPUAll()                   (PT3PU = 0xff)

#define GPIO_PT3SETDA(BitSet)                (PT3DA |= (1 << BitSet))   //PT3.1~3.7
#define GPIO_PT3CLRDA(BitSet)                (PT3DA &= ~ (1 << BitSet)) //PT3.1~3.7

#define GPIO_PT3GET(BitSet)                  (PT3 & (1 << BitSet))
#define GPIO_PT3SET(BitSet)                  (PT3 |= (1 << BitSet))
#define GPIO_PT3CLR(BitSet)                  (PT3 &= ~(1 << BitSet))


//GPort0 //
#define GPIO_GTBI2Set(GTBI2Set)              (GPort0 = ((GPort0 & (~GTBI2_MSK )) | GTBI2Set))
#define GPIO_GTBI1Set(GTBI1Set)              (GPort0 = ((GPort0 & (~GTBI1_MSK )) | GTBI1Set))
#define GPIO_GTBI0Set(GTBI0Set)              (GPort0 = ((GPort0 & (~GTBI0_MSK )) | GTBI0Set))

//GPort1 //
#define GPIO_GBuzSet(GBuzSet)                (GPort1 = ((GPort1 & (~GBuz_MSK )) | GBuzSet))
#define GPIO_GTCI2Set(GTCI2Set)              (GPort1 = ((GPort1 & (~GTCI2_MSK )) | GTCI2Set))
#define GPIO_GTCI1Set(GTCI1Set)              (GPort1 = ((GPort1 & (~GTCI1_MSK )) | GTCI1Set))

//GPort2 //
#define GPIO_GPWM1Set(GPWM1Set)              (GPort2 = ((GPort2 & (~GPWM1_MSK )) | GPWM1Set))
#define GPIO_GPWM0Set(GPWM0Set)              (GPort2 = ((GPort2 & (~GPWM0_MSK )) | GPWM0Set))

//GPort3 //
#define GPIO_GPWM3Set(GPWM3Set)              (GPort3 = ((GPort3 & (~GPWM3_MSK )) | GPWM3Set))
#define GPIO_GPWM2Set(GPWM2Set)              (GPort3 = ((GPort3 & (~GPWM2_MSK )) | GPWM2Set))

//GPort4 //
#define GPIO_GSCL2Set(GSCL2Set)              (GPort4 = ((GPort4 & (~GSCL2_MSK )) | GSCL2Set))
#define GPIO_GSCLSet(GSCLSet)                (GPort4 = ((GPort4 & (~GSCL_MSK )) | GSCLSet))
#define GPIO_GSPISet(GSPISet)                (GPort4 = ((GPort4 & (~GSPI_MSK )) | GSPISet))

//GPort5 //
#define GPIO_GTX2Set(GTX2Set)              (GPort5 = ((GPort5 & (~GTX2_MSK )) | GTX2Set))
#define GPIO_GTXSet(GTXSet)                (GPort5 = ((GPort5 & (~GTX_MSK )) | GTXSet))


//Smoke Detector//
#define GPIO_GetPT1Data(PT1Data)             PT1Data=PT1
#define GPIO_GetPT2Data(PT2Data)             PT2Data=PT2
#define GPIO_GetPT3Data(PT3Data)             PT3Data=PT3

/*-------------------------------------------------------------------------------------------------|
|  Function call:                                                                                  |
|    For general and functional register access.                                                   |
|-------------------------------------------------------------------------------------------------*/

