/**************************************************************************************************|
|* Copyright 2021 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|* - Generic Peripheral Library: A general and functional interface for the specific Peripheral   *|
|* - Low Level Peripheral Access: Register-Bits Level access Macro, user must take care           *|
|*   of calling procedure and hardware constraints                                                *|
|* - Support Target: HY17M Series                                                                 *|
|**************************************************************************************************/
 
/**************************************************************************************************|
|*                               Peripheral Register Bits field                                   *|
|**************************************************************************************************/
// INTE0 //
#define GIE                        7
#define GIE_MSK                   (1 << GIE)
#define GIE_ENABLE                (1 << GIE)
#define GIE_DISABLE               (0 << GIE)

#define TA1CIE                     6
#define TA1CIE_MSK                (1 << TA1CIE)
#define TA1CIE_ENABLE             (1 << TA1CIE)
#define TA1CIE_DISABLE            (0 << TA1CIE)

#define ADCIE                       5
#define ADCIE_MSK                  (1 << ADCIE)
#define ADCIE_ENABLE               (1 << ADCIE)
#define ADCIE_DISABLE              (0 << ADCIE)

#define WDTIE                      4
#define WDTIE_MSK                 (1 << WDTIE)
#define WDTIE_ENABLE              (1 << WDTIE)
#define WDTIE_DISABLE             (0 << WDTIE)

#define TB1IE                      3
#define TB1IE_MSK                 (1 << TB1IE)
#define TB1IE_ENABLE              (1 << TB1IE)
#define TB1IE_DISABLE             (0 << TB1IE)

#define E1IE                       1
#define E1IE_MSK                  (1 << E1IE)
#define E1IE_ENABLE               (1 << E1IE)
#define E1IE_DISABLE              (0 << E1IE)

#define E0IE                       0
#define E0IE_MSK                  (1 << E0IE)
#define E0IE_ENABLE               (1 << E0IE)
#define E0IE_DISABLE              (0 << E0IE)

//// INTE1 //
#define TA1IE                      7
#define TA1IE_MSK                 (1 << TA1IE)
#define TA1IE_ENABLE              (1 << TA1IE)
#define TA1IE_DISABLE             (0 << TA1IE)

#define SPIIE                      6
#define SPIIE_MSK                 (1 << SPIIE)
#define SPIIE_ENABLE              (1 << SPIIE)
#define SPIIE_DISABLE             (0 << SPIIE)

#define TXIE                       5
#define TXIE_MSK                  (1 << TXIE)
#define TXIE_ENABLE               (1 << TXIE)
#define TXIE_DISABLE              (0 << TXIE)

#define RCIE                       4
#define RCIE_MSK                  (1 << RCIE)
#define RCIE_ENABLE               (1 << RCIE)
#define RCIE_DISABLE              (0 << RCIE)

#define I2CERIE                    3
#define I2CERIE_MSK               (1 << I2CERIE)
#define I2CERIE_ENABLE            (1 << I2CERIE)
#define I2CERIE_DISABLE           (0 << I2CERIE)

#define I2CIE                      2
#define I2CIE_MSK                 (1 << I2CIE)
#define I2CIE_ENABLE              (1 << I2CIE)
#define I2CIE_DISABLE             (0 << I2CIE)


#define E3IE                       1
#define E3IE_MSK                  (1 << E3IE)
#define E3IE_ENABLE               (1 << E3IE)
#define E3IE_DISABLE              (0 << E3IE)

#define E2IE                       0
#define E2IE_MSK                  (1 << E2IE)
#define E2IE_ENABLE               (1 << E2IE)
#define E2IE_DISABLE              (0 << E2IE)

//// INTE2 //
#define TA2IE                      7
#define TA2IE_MSK                 (1 << TA2IE)
#define TA2IE_ENABLE              (1 << TA2IE)
#define TA2IE_DISABLE             (0 << TA2IE)

#define TA2CIE                     6
#define TA2CIE_MSK                (1 << TA2CIE)
#define TA2CIE_ENABLE             (1 << TA2CIE)
#define TA2CIE_DISABLE            (0 << TA2CIE)

#define TC11IE                     5
#define TC11IE_MSK                (1 << TC11IE)
#define TC11IE_ENABLE             (1 << TC11IE)
#define TC11IE_DISABLE            (0 << TC11IE)

#define TC10IE                     4
#define TC10IE_MSK                (1 << TC10IE)
#define TC10IE_ENABLE             (1 << TC10IE)
#define TC10IE_DISABLE            (0 << TC10IE)

#define CMPIE                      2
#define CMPIE_MSK                 (1 << CMPIE)
#define CMPIE_ENABLE              (1 << CMPIE)
#define CMPIE_DISABLE             (0 << CMPIE)

#define TB2IE                      1
#define TB2IE_MSK                 (1 << TB2IE)
#define TB2IE_ENABLE              (1 << TB2IE)
#define TB2IE_DISABLE             (0 << TB2IE)

#define BOR2IE                     0
#define BOR2IE_MSK                (1 << BOR2IE)
#define BOR2IE_ENABLE             (1 << BOR2IE)
#define BOR2IE_DISABLE            (0 << BOR2IE)

//// INTE3 //
#define TX2IE                      5
#define TX2IE_MSK                 (1 << TX2IE)
#define TX2IE_ENABLE              (1 << TX2IE)
#define TX2IE_DISABLE             (0 << TX2IE)

#define RC2IE                      4
#define RC2IE_MSK                 (1 << RC2IE)
#define RC2IE_ENABLE              (1 << RC2IE)
#define RC2IE_DISABLE             (0 << RC2IE)

#define TC21IE                     3
#define TC21IE_MSK                (1 << TC21IE)
#define TC21IE_ENABLE             (1 << TC21IE)
#define TC21IE_DISABLE            (0 << TC21IE)

#define TC20IE                     2
#define TC20IE_MSK                (1 << TC20IE)
#define TC20IE_ENABLE             (1 << TC20IE)
#define TC20IE_DISABLE            (0 << TC20IE)

#define I2CER2IE                   1
#define I2CER2IE_MSK              (1 << I2CER2IE)
#define I2CER2IE_ENABLE           (1 << I2CER2IE)
#define I2CER2IE_DISABLE          (0 << I2CER2IE)

#define I2C2IE                     0
#define I2C2IE_MSK                (1 << I2C2IE)
#define I2C2IE_ENABLE             (1 << I2C2IE)
#define I2C2IE_DISABLE            (0 << I2C2IE)

// INTF0 //
#define TA1CIF                     6
#define TA1CIF_MSK                (1 << TA1CIF)
#define TA1CIF_SET                (1 << TA1CIF)

#define ADCIF                      5
#define ADCIF_MSK                 (1 << ADCIF)
#define ADCIF_SET                 (1 << ADCIF)

#define WDTIF                      4
#define WDTIF_MSK                 (1 << WDTIF)
#define WDTIF_SET                 (1 << WDTIF)

#define TB1IF                      3
#define TB1IF_MSK                 (1 << TB1IF)
#define TB1IF_SET                 (1 << TB1IF)

#define E1IF                       1
#define E1IF_MSK                  (1 << E1IF)
#define E1IF_SET                  (1 << E1IF)

#define E0IF                       0
#define E0IF_MSK                  (1 << E0IF)
#define E0IF_SET                  (1 << E0IF)

// INTF1 //
#define TA1IF                      7
#define TA1IF_MSK                 (1 << TA1IF)
#define TA1IF_SET                 (1 << TA1IF)

#define SPIIF                      6
#define SPIIF_MSK                 (1 << SPIIF)
#define SPIIF_SET                 (1 << SPIIF)

#define TXIF                       5
#define TXIF_MSK                   (1 << TXIF)
#define TXIF_SET                   (1 << TXIF)

#define RCIF                       4
#define RCIF_MSK                   (1 << RCIF)
#define RCIF_SET                   (1 << RCIF)

#define I2CERIF                    3
#define I2CERIF_MSK                (1 << I2CERIF)
#define I2CERIF_SET                (1 << I2CERIF)

#define I2CIF                      2
#define I2CIF_MSK                  (1 << I2CIF)
#define I2CIF_SET                  (1 << I2CIF)

#define E3IF                       1
#define E3IF_MSK                   (1 << E3IF)
#define E3IF_SET                   (1 << E3IF)

#define E2IF                       0
#define E2IF_MSK                   (1 << E2IF)
#define E2IF_SET                   (1 << E2IF)

// INTF2 //
#define TA2IF                       7
#define TA2IF_MSK                  (1 << TA2IF)
#define TA2IF_SET                  (1 << TA2IF)

#define TA2CIF                      6
#define TA2CIF_MSK                 (1 << TA2CIF)
#define TA2CIF_SET                 (1 << TA2CIF)

#define TC1IF                       5
#define TC1IF_MSK                  (1 << TC1IF)
#define TC1IF_SET                  (1 << TC1IF)

#define TC0IF                       4
#define TC0IF_MSK                  (1 << TC0IF)
#define TC0IF_SET                  (1 << TC0IF)

#define CMPIF                       2
#define CMPIF_MSK                  (1 << CMPIF)
#define CMPIF_SET                  (1 << CMPIF)

#define TB2IF                       1
#define TB2IF_MSK                  (1 << TB2IF)
#define TB2IF_SET                  (1 << TB2IF)

#define BOR2IF                      0
#define BOR2IF_MSK                 (1 << BOR2IF)
#define BOR2IF_SET                 (1 << BOR2IF)

// INTF3 //
#define GCRstIF2                    6
#define GCRstIF2_MSK               (1 << GCRstIF2)
#define GCRstIF2_SET               (1 << GCRstIF2)

#define TX2IF                       5
#define TX2IF_MSK                   (1 << TX2IF)
#define TX2IF_SET                   (1 << TX2IF)

#define RC2IF                       4
#define RC2IF_MSK                   (1 << RC2IF)
#define RC2IF_SET                   (1 << RC2IF)

#define TC21IF                       3
#define TC21IF_MSK                  (1 << TC21IF)
#define TC21IF_SET                  (1 << TC21IF)

#define TC20IF                       2
#define TC20IF_MSK                  (1 << TC20IF)
#define TC20IF_SET                  (1 << TC20IF)

#define I2CER2IF                    1
#define I2CER2IF_MSK                (1 << I2CER2IF)
#define I2CER2IF_SET                (1 << I2CER2IF)

#define I2C2IF                      0
#define I2C2IF_MSK                  (1 << I2C2IF)
#define I2C2IF_SET                  (1 << I2C2IF)

// PT1M1 //
#define INTEG0                    0
#define INTEG0_MSK               (3 << INTEG0)
#define INTEG0_LEV               (3 << INTEG0)
//#define INTEG0_LEV             (2 << INTEG0)
#define INTEG0_EDGERISE          (1 << INTEG0)
#define INTEG0_EDGEFALL          (0 << INTEG0)

#define INTEG1                    2
#define INTEG1_MSK               (3 << INTEG1)
#define INTEG1_LEV               (3 << INTEG1)
//#define INTEG1_LEV             (2 << INTEG1)
#define INTEG1_EDGERISE          (1 << INTEG1)
#define INTEG1_EDGEFALL          (0 << INTEG1)

#define INTEG2                    4
#define INTEG2_MSK               (3 << INTEG2)
#define INTEG2_LEV               (3 << INTEG2)
//#define INTEG2_LEV             (2 << INTEG2)
#define INTEG2_EDGERISE          (1 << INTEG2)
#define INTEG2_EDGEFALL          (0 << INTEG2)

#define INTEG3                    6
#define INTEG3_MSK               (3 << INTEG3)
#define INTEG3_LEV               (3 << INTEG3)
//#define INTEG3_LEV             (2 << INTEG3)
#define INTEG3_EDGERISE          (1 << INTEG3)
#define INTEG3_EDGEFALL          (0 << INTEG3)

// PT1INT //
#define INTEG16                    6
#define INTEG16_MSK               (1 << INTEG16)
#define INTEG16_EDGERISE          (1 << INTEG16)
#define INTEG16_EDGEFALL          (0 << INTEG16)

#define INTEG15                    5
#define INTEG15_MSK               (1 << INTEG15)
#define INTEG15_EDGERISE          (1 << INTEG15)
#define INTEG15_EDGEFALL          (0 << INTEG15)

#define INTEG14                    4
#define INTEG14_MSK               (1 << INTEG14)
#define INTEG14_EDGERISE          (1 << INTEG14)
#define INTEG14_EDGEFALL          (0 << INTEG14)


// PT1INTE //
#define INTE16                       6
#define INTE16_MSK                  (1 << INTE16)
#define INTE16_ENABLE               (1 << INTE16)
#define INTE16_DISABLE              (0 << INTE16)

#define INTE15                       5
#define INTE15_MSK                  (1 << INTE15)
#define INTE15_ENABLE               (1 << INTE15)
#define INTE15_DISABLE              (0 << INTE15)

#define INTE14                       4
#define INTE14_MSK                  (1 << INTE14)
#define INTE14_ENABLE               (1 << INTE14)
#define INTE14_DISABLE              (0 << INTE14)

// PT1INTF //
#define INTF16                       6
#define INTF16_MSK                  (1 << INTF16)
#define INTF16_SET                  (1 << INTF16)

#define INTF15                       5
#define INTF15_MSK                  (1 << INTF15)
#define INTF15_SET                  (1 << INTF15)

#define INTF14                       4
#define INTF14_MSK                  (1 << INTF14)
#define INTF14_SET                  (1 << INTF14)

// PT2INT //
#define INTEG27                       7
#define INTEG27_MSK                  (1 << INTEG27)
#define INTEG27_EDGERISE             (1 << INTEG27)
#define INTEG27_EDGEFALL             (0 << INTEG27)

#define INTEG26                       6
#define INTEG26_MSK                  (1 << INTEG26)
#define INTEG26_EDGERISE             (1 << INTEG26)
#define INTEG26_EDGEFALL             (0 << INTEG26)

#define INTEG25                       5
#define INTEG25_MSK                  (1 << INTEG25)
#define INTEG25_EDGERISE             (1 << INTEG25)
#define INTEG25_EDGEFALL             (0 << INTEG25)

#define INTEG24                       4
#define INTEG24_MSK                  (1 << INTEG24)
#define INTEG24_EDGERISE             (1 << INTEG24)
#define INTEG24_EDGEFALL             (0 << INTEG24)

#define INTEG23                       3
#define INTEG23_MSK                  (1 << INTEG23)
#define INTEG23_EDGERISE             (1 << INTEG23)
#define INTEG23_EDGEFALL             (0 << INTEG23)

#define INTEG22                       2
#define INTEG22_MSK                  (1 << INTEG22)
#define INTEG22_EDGERISE             (1 << INTEG22)
#define INTEG22_EDGEFALL             (0 << INTEG22)

#define INTEG21                       1
#define INTEG21_MSK                  (1 << INTEG21)
#define INTEG21_EDGERISE             (1 << INTEG21)
#define INTEG21_EDGEFALL             (0 << INTEG21)

#define INTEG20                       0
#define INTEG20_MSK                  (1 << INTEG20)
#define INTEG20_EDGERISE             (1 << INTEG20)
#define INTEG20_EDGEFALL             (0 << INTEG20)

// PT2INTE //
#define INTE27                       7
#define INTE27_MSK                  (1 << INTE27)
#define INTE27_ENABLE               (1 << INTE27)
#define INTE27_DISABLE              (0 << INTE27)

#define INTE26                       6
#define INTE26_MSK                  (1 << INTE26)
#define INTE26_ENABLE               (1 << INTE26)
#define INTE26_DISABLE              (0 << INTE26)

#define INTE25                       5
#define INTE25_MSK                  (1 << INTE25)
#define INTE25_ENABLE               (1 << INTE25)
#define INTE25_DISABLE              (0 << INTE25)

#define INTE24                       4
#define INTE24_MSK                  (1 << INTE24)
#define INTE24_ENABLE               (1 << INTE24)
#define INTE24_DISABLE              (0 << INTE24)

#define INTE23                       3
#define INTE23_MSK                  (1 << INTE23)
#define INTE23_ENABLE               (1 << INTE23)
#define INTE23_DISABLE              (0 << INTE23)

#define INTE22                       2
#define INTE22_MSK                  (1 << INTE22)
#define INTE22_ENABLE               (1 << INTE22)
#define INTE22_DISABLE              (0 << INTE22)

#define INTE21                       1
#define INTE21_MSK                  (1 << INTE21)
#define INTE21_ENABLE               (1 << INTE21)
#define INTE21_DISABLE              (0 << INTE21)

#define INTE20                       0
#define INTE20_MSK                  (1 << INTE20)
#define INTE20_ENABLE               (1 << INTE20)
#define INTE20_DISABLE              (0 << INTE20)

// PT2INTF //
#define INTF27                       7
#define INTF27_MSK                  (1 << INTF27)
#define INTF27_SET                  (1 << INTF27)

#define INTF26                       6
#define INTF26_MSK                  (1 << INTF26)
#define INTF26_SET                  (1 << INTF26)

#define INTF25                       5
#define INTF25_MSK                  (1 << INTF25)
#define INTF25_SET                  (1 << INTF25)

#define INTF24                       4
#define INTF24_MSK                  (1 << INTF24)
#define INTF24_SET                  (1 << INTF24)

#define INTF23                       3
#define INTF23_MSK                  (1 << INTF23)
#define INTF23_SET                  (1 << INTF23)

#define INTF22                       2
#define INTF22_MSK                  (1 << INTF22)
#define INTF22_SET                  (1 << INTF22)

#define INTF21                       1
#define INTF21_MSK                  (1 << INTF21)
#define INTF21_SET                  (1 << INTF21)

#define INTF20                       0
#define INTF20_MSK                  (1 << INTF20)
#define INTF20_SET                  (1 << INTF20)

// PT3INT //
#define INTEG37                    7
#define INTEG37_MSK               (1 << INTEG37)
#define INTEG37_EDGERISE          (1 << INTEG37)
#define INTEG37_EDGEFALL          (0 << INTEG37)

#define INTEG36                    6
#define INTEG36_MSK               (1 << INTEG36)
#define INTEG36_EDGERISE          (1 << INTEG36)
#define INTEG36_EDGEFALL          (0 << INTEG36)

#define INTEG35                    5
#define INTEG35_MSK               (1 << INTEG35)
#define INTEG35_EDGERISE          (1 << INTEG35)
#define INTEG35_EDGEFALL          (0 << INTEG35)

#define INTEG34                    4
#define INTEG34_MSK               (1 << INTEG34)
#define INTEG34_EDGERISE          (1 << INTEG34)
#define INTEG34_EDGEFALL          (0 << INTEG34)

#define INTEG33                    3
#define INTEG33_MSK               (1 << INTEG33)
#define INTEG33_EDGERISE          (1 << INTEG33)
#define INTEG33_EDGEFALL          (0 << INTEG33)

#define INTEG32                    2
#define INTEG32_MSK               (1 << INTEG32)
#define INTEG32_EDGERISE          (1 << INTEG32)
#define INTEG32_EDGEFALL          (0 << INTEG32)

#define INTEG31                    1
#define INTEG31_MSK               (1 << INTEG31)
#define INTEG31_EDGERISE          (1 << INTEG31)
#define INTEG31_EDGEFALL          (0 << INTEG31)

#define INTEG30                    0
#define INTEG30_MSK               (1 << INTEG30)
#define INTEG30_EDGERISE          (1 << INTEG30)
#define INTEG30_EDGEFALL          (0 << INTEG30)


// PT3INTE //
#define INTE37                       7
#define INTE37_MSK                  (1 << INTE37)
#define INTE37_ENABLE               (1 << INTE37)
#define INTE37_DISABLE              (0 << INTE37)

#define INTE36                       6
#define INTE36_MSK                  (1 << INTE36)
#define INTE36_ENABLE               (1 << INTE36)
#define INTE36_DISABLE              (0 << INTE36)

#define INTE35                       5
#define INTE35_MSK                  (1 << INTE35)
#define INTE35_ENABLE               (1 << INTE35)
#define INTE35_DISABLE              (0 << INTE35)

#define INTE34                       4
#define INTE34_MSK                  (1 << INTE34)
#define INTE34_ENABLE               (1 << INTE34)
#define INTE34_DISABLE              (0 << INTE34)

#define INTE33                       3
#define INTE33_MSK                  (1 << INTE33)
#define INTE33_ENABLE               (1 << INTE33)
#define INTE33_DISABLE              (0 << INTE33)

#define INTE32                       2
#define INTE32_MSK                  (1 << INTE32)
#define INTE32_ENABLE               (1 << INTE32)
#define INTE32_DISABLE              (0 << INTE32)

#define INTE31                       1
#define INTE31_MSK                  (1 << INTE31)
#define INTE31_ENABLE               (1 << INTE31)
#define INTE31_DISABLE              (0 << INTE31)

#define INTE30                       0
#define INTE30_MSK                  (1 << INTE30)
#define INTE30_ENABLE               (1 << INTE30)
#define INTE30_DISABLE              (0 << INTE30)

// PT3INTF //
#define INTF37                       7
#define INTF37_MSK                  (1 << INTF37)
#define INTF37_SET                  (1 << INTF37)

#define INTF36                       6
#define INTF36_MSK                  (1 << INTF36)
#define INTF36_SET                  (1 << INTF36)

#define INTF35                       5
#define INTF35_MSK                  (1 << INTF35)
#define INTF35_SET                  (1 << INTF35)

#define INTF34                       4
#define INTF34_MSK                  (1 << INTF34)
#define INTF34_SET                  (1 << INTF34)

#define INTF33                       3
#define INTF33_MSK                  (1 << INTF33)
#define INTF33_SET                  (1 << INTF33)

#define INTF32                       2
#define INTF32_MSK                  (1 << INTF32)
#define INTF32_SET                  (1 << INTF32)

#define INTF31                       1
#define INTF31_MSK                  (1 << INTF31)
#define INTF31_SET                  (1 << INTF31)

#define INTF30                       0
#define INTF30_MSK                  (1 << INTF30)
#define INTF30_SET                  (1 << INTF30)


/**************************************************************************************************|
|*                                      Function Level                                            *|
|**************************************************************************************************/

/*-------------------------------------------------------------------------------------------------|
|  Function-like Macro:                                                                            |
|    Register Bits field Configuration without function call overhead,                             |
|    user should take care of detail of h/w behavior and constrains.                               |
|-------------------------------------------------------------------------------------------------*/
#define INTF0_SET(INTF0Sel)         (INTF0 |= (1<<INTF0Sel))
#define INTF0_CLR(INTF0Sel)         (INTF0 &= ~(1<<INTF0Sel))
#define INTF1_SET(INTF1Sel)         (INTF1 |= (1<<INTF1Sel))
#define INTF1_CLR(INTF1Sel)         (INTF1 &= ~(1<<INTF1Sel))
#define INTF2_SET(INTF2Sel)         (INTF2 |= (1<<INTF2Sel))
#define INTF2_CLR(INTF2Sel)         (INTF2 &= ~(1<<INTF2Sel))
#define INTF3_SET(INTF3Sel)         (INTF3 |= (1<<INTF3Sel))
#define INTF3_CLR(INTF3Sel)         (INTF3 &= ~(1<<INTF3Sel))


#define GIE_Enable()                (INTE0 |= GIE_ENABLE)
#define GIE_Disable()               (INTE0 &= (~GIE_MSK))



#define TA1CIE_Enable()             (INTE0 |= TA1CIE_ENABLE)
#define TA1CIE_Disable()            (INTE0 &= (~TA1CIE_MSK))
#define TA1CIF_IsFlag()             (INTF0 & TA1CIF_SET)
#define TA1CIF_ClearFlag()          (INTF0 &= (~TA1CIF_MSK))

#define ADCIE_Enable()               (INTE0 |= ADCIE_ENABLE)
#define ADCIE_Disable()              (INTE0 &= (~ADCIE_MSK))
#define ADCIF_IsFlag()               (INTF0 & ADCIF_SET)
#define ADCIF_ClearFlag()            (INTF0 &= (~ADCIF_MSK))

#define WDTIE_Enable()              (INTE0 |= WDTIE_ENABLE)
#define WDTIE_Disable()             (INTE0 &= (~WDTIE_MSK))
#define WDTIF_IsFlag()              (INTF0 & WDTIF_SET)
#define WDTIF_ClearFlag()           (INTF0 &= (~WDTIF_MSK))

#define TB1IE_Enable()              (INTE0 |= TB1IE_ENABLE)
#define TB1IE_Disable()             (INTE0 &= (~TB1IE_MSK))
#define TB1IF_IsFlag()              (INTF0 & TB1IF_SET)
#define TB1IF_ClearFlag()           (INTF0 &= (~TB1IF_MSK))

#define E1IE_Enable()               (INTE0 |= E1IE_ENABLE)
#define E1IE_Disable()              (INTE0 &= (~E1IE_MSK))
#define E1IF_IsFlag()               (INTF0 & E1IF_SET)
#define E1IF_ClearFlag()            (INTF0 &= (~E1IF_MSK))

#define E0IE_Enable()               (INTE0 |= E0IE_ENABLE)
#define E0IE_Disable()              (INTE0 &= (~E0IE_MSK))
#define E0IF_IsFlag()               (INTF0 & E0IF_SET)
#define E0IF_ClearFlag()            (INTF0 &= (~E0IF_MSK))

#define TA1IE_Enable()              (INTE1 |= TA1IE_ENABLE)
#define TA1IE_Disable()             (INTE1 &= (~TA1IE_MSK))
#define TA1IF_IsFlag()              (INTF1 & TA1IF_SET)
#define TA1IF_ClearFlag()           (INTF1 &= (~TA1IF_MSK))

#define SPIIE_Enable()              (INTE1 |= SPIIE_ENABLE)
#define SPIIE_Disable()             (INTE1 &= (~SPIIE_MSK))
#define SPIIF_IsFlag()              (INTF1 & SPIIF_SET)
#define SPIIF_ClearFlag()           (INTF1 &= (~SPIIF_MSK))

#define TXIE_Enable()               (INTE1 |= TXIE_ENABLE)
#define TXIE_Disable()              (INTE1 &= (~TXIE_MSK))
#define TXIF_IsFlag()               (INTF1 & TXIF_SET)
#define TXIF_ClearFlag()            (INTF1 &= (~TXIF_MSK))

#define RCIE_Enable()               (INTE1 |= RCIE_ENABLE)
#define RCIE_Disable()              (INTE1 &= (~RCIE_MSK))
#define RCIF_IsFlag()               (INTF1 & RCIF_SET)
#define RCIF_ClearFlag()            (INTF1 &= (~RCIF_MSK))

#define I2CERIE_Enable()            (INTE1 |= I2CERIE_ENABLE)
#define I2CERIE_Disable()           (INTE1 &= (~I2CERIE_MSK))
#define I2CERIF_IsFlag()            (INTF1 & I2CERIF_SET)
#define I2CERIF_ClearFlag()         (INTF1 &= (~I2CERIF_MSK))

#define I2CIE_Enable()              (INTE1 |= I2CIE_ENABLE)
#define I2CIE_Disable()             (INTE1 &= (~I2CIE_MSK))
#define I2CIF_IsFlag()              (INTF1 & I2CIF_SET)
#define I2CIF_ClearFlag()           (INTF1 &= (~I2CIF_MSK))

#define E3IE_Enable()               (INTE1 |= E3IE_ENABLE)
#define E3IE_Disable()              (INTE1 &= (~E3IE_MSK))
#define E3IF_IsFlag()               (INTF1 & E3IF_SET)
#define E3IF_ClearFlag()            (INTF1 &= (~E3IF_MSK))

#define E2IE_Enable()               (INTE1 |= E2IE_ENABLE)
#define E2IE_Disable()              (INTE1 &= (~E2IE_MSK))
#define E2IF_IsFlag()               (INTF1 & E2IF_SET)
#define E2IF_ClearFlag()            (INTF1 &= (~E2IF_MSK))

#define TA2IE_Enable()              (INTE2 |= TA2IE_ENABLE)
#define TA2IE_Disable()             (INTE2 &= (~TA2IE_MSK))
#define TA2IF_IsFlag()              (INTF2 & TA2IF_SET)
#define TA2IF_ClearFlag()           (INTF2 &= (~TA2IF_MSK))

#define TA2CIE_Enable()             (INTE2 |= TA2CIE_ENABLE)
#define TA2CIE_Disable()            (INTE2 &= (~TA2CIE_MSK))
#define TA2CIF_IsFlag()             (INTF2 & TA2CIF_SET)
#define TA2CIF_ClearFlag()          (INTF2 &= (~TA2CIF_MSK))

#define TC11IE_Enable()             (INTE2 |= TC11IE_ENABLE)
#define TC11IE_Disable()            (INTE2 &= (~TC11IE_MSK))
#define TC11IF_IsFlag()             (INTF2 & TC11IF_SET)
#define TC11IF_ClearFlag()          (INTF2 &= (~TC11IF_MSK))

#define TC10IE_Enable()             (INTE2 |= TC10IE_ENABLE)
#define TC10IE_Disable()            (INTE2 &= (~TC10IE_MSK))
#define TC10IF_IsFlag()             (INTF2 & TC10IF_SET)
#define TC10IF_ClearFlag()          (INTF2 &= (~TC10IF_MSK))

#define CMPIE_Enable()              (INTE2 |= CMPIE_ENABLE)
#define CMPIE_Disable()             (INTE2 &= (~CMPIE_MSK))
#define CMPIF_IsFlag()              (INTF2 & CMPIF_SET)
#define CMPIF_ClearFlag()           (INTF2 &= (~CMPIF_MSK))

#define TB2IE_Enable()              (INTE2 |= TB2IE_ENABLE)
#define TB2IE_Disable()             (INTE2 &= (~TB2IE_MSK))
#define TB2IF_IsFlag()              (INTF2 & TB2IF_SET)
#define TB2IF_ClearFlag()           (INTF2 &= (~TB2IF_MSK))

#define BOR2IE_Enable()             (INTE2 |= BOR2IE_ENABLE)
#define BOR2IE_Disable()            (INTE2 &= (~BOR2IE_MSK))
#define BOR2IF_IsFlag()             (INTF2 & BOR2IF_SET)
#define BOR2IF_ClearFlag()          (INTF2 &= (~BOR2IF_MSK))

#define TX2IE_Enable()               (INTE3 |= TX2IE_ENABLE)
#define TX2IE_Disable()              (INTE3 &= (~TX2IE_MSK))
#define TX2IF_IsFlag()               (INTF3 & TX2IF_SET)
#define TX2IF_ClearFlag()            (INTF3 &= (~TX2IF_MSK))

#define RC2IE_Enable()               (INTE3 |= RC2IE_ENABLE)
#define RC2IE_Disable()              (INTE3 &= (~RC2IE_MSK))
#define RC2IF_IsFlag()               (INTF3 & RC2IF_SET)
#define RC2IF_ClearFlag()            (INTF3 &= (~RC2IF_MSK))

#define TC21IE_Enable()             (INTE3 |= TC21IE_ENABLE)
#define TC21IE_Disable()            (INTE3 &= (~TC21IE_MSK))
#define TC21IF_IsFlag()             (INTF3 & TC21IF_SET)
#define TC21IF_ClearFlag()          (INTF3 &= (~TC21IF_MSK))

#define TC20IE_Enable()             (INTE3 |= TC20IE_ENABLE)
#define TC20IE_Disable()            (INTE3 &= (~TC20IE_MSK))
#define TC20IF_IsFlag()             (INTF3 & TC20IF_SET)
#define TC20IF_ClearFlag()          (INTF3 &= (~TC20IF_MSK))

#define I2CER2IE_Enable()            (INTE3 |= I2CER2IE_ENABLE)
#define I2CER2IE_Disable()           (INTE3 &= (~I2CER2IE_MSK))
#define I2CER2IF_IsFlag()            (INTF3 & I2CER2IF_SET)
#define I2CER2IF_ClearFlag()         (INTF3 &= (~I2CER2IF_MSK))

#define I2C2IE_Enable()              (INTE3 |= I2C2IE_ENABLE)
#define I2C2IE_Disable()             (INTE3 &= (~I2C2IE_MSK))
#define I2C2IF_IsFlag()              (INTF3 & I2C2IF_SET)
#define I2C2IF_ClearFlag()           (INTF3 &= (~I2C2IF_MSK))

#define INTEG16_Edgerise()          (PT1INT |= INTEG16_EDGERISE)
#define INTEG16_Edgefall()           (PT1INT &= (~INTEG16_MSK))
#define INTE16_Enable()             (PT1INTE |= INTE16_ENABLE)
#define INTE16_Disable()            (PT1INTE &= (~INTE16_MSK))
#define INTF16_IsFlag()               (PT1INTF & INTF16_SET)
#define INTF16_ClearFlag()         (PT1INTF &= (~INTF16_MSK))

#define INTEG15_Edgerise()          (PT1INT |= INTEG15_EDGERISE)
#define INTEG15_Edgefall()           (PT1INT &= (~INTEG15_MSK))
#define INTE15_Enable()             (PT1INTE |= INTE15_ENABLE)
#define INTE15_Disable()            (PT1INTE &= (~INTE15_MSK))
#define INTF15_IsFlag()             (PT1INTF & INTF15_SET)
#define INTF15_ClearFlag()          (PT1INTF &= (~INTF15_MSK))

#define INTEG14_Edgerise()          (PT1INT |= INTEG14_EDGERISE)
#define INTEG14_Edgefall()           (PT1INT &= (~INTEG14_MSK))
#define INTE14_Enable()             (PT1INTE |= INTE14_ENABLE)
#define INTE14_Disable()            (PT1INTE &= (~INTE14_MSK))
#define INTF14_IsFlag()             (PT1INTF & INTF14_SET)
#define INTF14_ClearFlag()          (PT1INTF &= (~INTF14_MSK))

#define INTEG3Sel(EG3Sel)               (PT1M1 = ((PT1M1 & (~INTEG3_MSK)) | EG3Sel))
#define INTEG2Sel(EG2Sel)               (PT1M1 = ((PT1M1 & (~INTEG2_MSK)) | EG2Sel))
#define INTEG1Sel(EG1Sel)               (PT1M1 = ((PT1M1 & (~INTEG1_MSK)) | EG1Sel))
#define INTEG0Sel(EG0Sel)               (PT1M1 = ((PT1M1 & (~INTEG0_MSK)) | EG0Sel))

#define INTEG27_Edgerise()          (PT2INT |= INTEG27_EDGERISE)
#define INTEG27_Edgefall()           (PT2INT &= (~INTEG27_MSK))
#define INTE27_Enable()             (PT2INTE |= INTE27_ENABLE)
#define INTE27_Disable()            (PT2INTE &= (~INTE27_MSK))
#define INTF27_IsFlag()             (PT2INTF & INTF27_SET)
#define INTF27_ClearFlag()          (PT2INTF &= (~INTF27_MSK))

#define INTEG26_Edgerise()          (PT2INT |= INTEG26_EDGERISE)
#define INTEG26_Edgefall()           (PT2INT &= (~INTEG26_MSK))
#define INTE26_Enable()             (PT2INTE |= INTE26_ENABLE)
#define INTE26_Disable()            (PT2INTE &= (~INTE26_MSK))
#define INTF26_IsFlag()             (PT2INTF & INTF26_SET)
#define INTF26_ClearFlag()          (PT2INTF &= (~INTF26_MSK))

#define INTEG25_Edgerise()          (PT2INT |= INTEG25_EDGERISE)
#define INTEG25_Edgefall()           (PT2INT &= (~INTEG25_MSK))
#define INTE25_Enable()             (PT2INTE |= INTE25_ENABLE)
#define INTE25_Disable()            (PT2INTE &= (~INTE25_MSK))
#define INTF25_IsFlag()             (PT2INTF & INTF25_SET)
#define INTF25_ClearFlag()          (PT2INTF &= (~INTF25_MSK))

#define INTEG24_Edgerise()          (PT2INT |= INTEG24_EDGERISE)
#define INTEG24_Edgefall()           (PT2INT &= (~INTEG24_MSK))
#define INTE24_Enable()             (PT2INTE |= INTE24_ENABLE)
#define INTE24_Disable()            (PT2INTE &= (~INTE24_MSK))
#define INTF24_IsFlag()             (PT2INTF & INTF24_SET)
#define INTF24_ClearFlag()          (PT2INTF &= (~INTF24_MSK))

#define INTEG23_Edgerise()          (PT2INT |= INTEG23_EDGERISE)
#define INTEG23_Edgefall()           (PT2INT &= (~INTEG23_MSK))
#define INTE23_Enable()             (PT2INTE |= INTE23_ENABLE)
#define INTE23_Disable()            (PT2INTE &= (~INTE23_MSK))
#define INTF23_IsFlag()             (PT2INTF & INTF23_SET)
#define INTF23_ClearFlag()          (PT2INTF &= (~INTF23_MSK))

#define INTEG22_Edgerise()          (PT2INT |= INTEG22_EDGERISE)
#define INTEG22_Edgefall()           (PT2INT &= (~INTEG22_MSK))
#define INTE22_Enable()             (PT2INTE |= INTE22_ENABLE)
#define INTE22_Disable()            (PT2INTE &= (~INTE22_MSK))
#define INTF22_IsFlag()             (PT2INTF & INTF22_SET)
#define INTF22_ClearFlag()          (PT2INTF &= (~INTF22_MSK))

#define INTEG21_Edgerise()          (PT2INT |= INTEG21_EDGERISE)
#define INTEG21_Edgefall()           (PT2INT &= (~INTEG21_MSK))
#define INTE21_Enable()             (PT2INTE |= INTE21_ENABLE)
#define INTE21_Disable()            (PT2INTE &= (~INTE21_MSK))
#define INTF21_IsFlag()             (PT2INTF & INTF21_SET)
#define INTF21_ClearFlag()          (PT2INTF &= (~INTF21_MSK))

#define INTEG20_Edgerise()          (PT2INT |= INTEG20_EDGERISE)
#define INTEG20_Edgefall()           (PT2INT &= (~INTEG20_MSK))
#define INTE20_Enable()             (PT2INTE |= INTE20_ENABLE)
#define INTE20_Disable()            (PT2INTE &= (~INTE20_MSK))
#define INTF20_IsFlag()             (PT2INTF & INTF20_SET)
#define INTF20_ClearFlag()          (PT2INTF &= (~INTF20_MSK))

#define INTEG37_Edgerise()          (PT3INT |= INTEG37_EDGERISE)
#define INTEG37_Edgefall()           (PT3INT &= (~INTEG37_MSK))
#define INTE37_Enable()             (PT3INTE |= INTE37_ENABLE)
#define INTE37_Disable()            (PT3INTE &= (~INTE37_MSK))
#define INTF37_IsFlag()             (PT3INTF & INTF37_SET)
#define INTF37_ClearFlag()          (PT3INTF &= (~INTF37_MSK))

#define INTEG36_Edgerise()          (PT3INT |= INTEG36_EDGERISE)
#define INTEG36_Edgefall()           (PT3INT &= (~INTEG36_MSK))
#define INTE36_Enable()             (PT3INTE |= INTE36_ENABLE)
#define INTE36_Disable()            (PT3INTE &= (~INTE36_MSK))
#define INTF36_IsFlag()             (PT3INTF & INTF36_SET)
#define INTF36_ClearFlag()          (PT3INTF &= (~INTF36_MSK))

#define INTEG35_Edgerise()          (PT3INT |= INTEG35_EDGERISE)
#define INTEG35_Edgefall()           (PT3INT &= (~INTEG35_MSK))
#define INTE35_Enable()             (PT3INTE |= INTE35_ENABLE)
#define INTE35_Disable()            (PT3INTE &= (~INTE35_MSK))
#define INTF35_IsFlag()             (PT3INTF & INTF35_SET)
#define INTF35_ClearFlag()          (PT3INTF &= (~INTF35_MSK))

#define INTEG34_Edgerise()          (PT3INT |= INTEG34_EDGERISE)
#define INTEG34_Edgefall()           (PT3INT &= (~INTEG34_MSK))
#define INTE34_Enable()             (PT3INTE |= INTE34_ENABLE)
#define INTE34_Disable()            (PT3INTE &= (~INTE34_MSK))
#define INTF34_IsFlag()             (PT3INTF & INTF34_SET)
#define INTF34_ClearFlag()          (PT3INTF &= (~INTF34_MSK))

#define INTEG33_Edgerise()          (PT3INT |= INTEG33_EDGERISE)
#define INTEG33_Edgefall()           (PT3INT &= (~INTEG33_MSK))
#define INTE33_Enable()             (PT3INTE |= INTE33_ENABLE)
#define INTE33_Disable()            (PT3INTE &= (~INTE33_MSK))
#define INTF33_IsFlag()             (PT3INTF & INTF33_SET)
#define INTF33_ClearFlag()          (PT3INTF &= (~INTF33_MSK))

#define INTEG32_Edgerise()          (PT3INT |= INTEG32_EDGERISE)
#define INTEG32_Edgefall()           (PT3INT &= (~INTEG32_MSK))
#define INTE32_Enable()             (PT3INTE |= INTE32_ENABLE)
#define INTE32_Disable()            (PT3INTE &= (~INTE32_MSK))
#define INTF32_IsFlag()             (PT3INTF & INTF32_SET)
#define INTF32_ClearFlag()          (PT3INTF &= (~INTF32_MSK))

#define INTEG31_Edgerise()          (PT3INT |= INTEG31_EDGERISE)
#define INTEG31_Edgefall()           (PT3INT &= (~INTEG31_MSK))
#define INTE31_Enable()             (PT3INTE |= INTE31_ENABLE)
#define INTE31_Disable()            (PT3INTE &= (~INTE31_MSK))
#define INTF31_IsFlag()             (PT3INTF & INTF31_SET)
#define INTF31_ClearFlag()          (PT3INTF &= (~INTF31_MSK))

#define INTEG30_Edgerise()          (PT3INT |= INTEG30_EDGERISE)
#define INTEG30_Edgefall()           (PT3INT &= (~INTEG30_MSK))
#define INTE30_Enable()             (PT3INTE |= INTE30_ENABLE)
#define INTE30_Disable()            (PT3INTE &= (~INTE30_MSK))
#define INTF30_IsFlag()             (PT3INTF & INTF30_SET)
#define INTF30_ClearFlag()          (PT3INTF &= (~INTF30_MSK))
/*-------------------------------------------------------------------------------------------------|
|  Function call:                                                                                  |
|    For general and functional register access.                                                   |
|-------------------------------------------------------------------------------------------------*/
