/**************************************************************************************************|
|* Copyright 2021 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|*                                                                                                *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Includes                                                                                      *|
|**************************************************************************************************/
#include <hy17m26sfr.h>
#include <PWR.h>
#include <ADC.h>
/**************************************************************************************************|
|*  Static Function                                                                               *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Generic Peripheral Library                                                                    *|
|**************************************************************************************************/
/*----------------------------------------------------------------------------------------------------------------------|
|  Function: PWR_VDDAOpen                                                                                       |
|                                                                                               				                               |
|  Parameters:                                                                                                                        |
|         vdda  		  - [in]  LDOC_2V4  / LDOC_2V6 / LDOC_2V9 / LDOC_3V3                    |
|                                 LDOC_3V6  / LDOC_4V0 / LDOC_4V5 / LDOC_5V0                     |
|                                                                                                                                              |
|  Returns:                                                                                                                               |
|         None                                                                                                                             |
|                                                                                                                                               |
|  Description:                                                                                                                          |
|         This function is used to open the PWR of VDDA                                                          |
|----------------------------------------------------------------------------------------------------------------------*/
void PWR_VDDAOpen(unsigned char vdda)    //VDDA regulated selector
{
	PWR_LDOPLEnable();	
	PWR_VDDASel(vdda);		//VDDA Voltage Selection
	PWR_LDOMode(LDOM_VDD);
    PWR_LDOEnable();		  //Enable VDDA
	
}

/**************************************************************************************************|
|*  Static Functions                                                                              *|
|**************************************************************************************************/
