 /**************************************************************************************************|
|* Copyright 2021 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|* - Generic Peripheral Library: A general and functional Interface for the specific Peripheral   *|
|* - Low Level Peripheral Access: Register-Bits Level access Macro, user must take care           *|
|*   of calling procedure and hardware constraints                                                *|
|* - Support Target: HY17M Series                                                                 *|
|**************************************************************************************************/
#include <CLK.h>
/**************************************************************************************************|
|*                               Peripheral Register Bits field                                   *|
|**************************************************************************************************/
// TMAxCN //
#define ENTMA                           7
#define ENTMA_MSK                      (1 << ENTMA)
#define ENTMA_ENABLE                   (1 << ENTMA)
#define ENTMA_DISABLE                  (0 << ENTMA)
                                        
#define TMACL                           6
#define TMACL_MSK                      (1 << TMACL)
#define TMACL_NORMAL                   (0 << TMACL)
#define TMACL_CLEAR                    (1 << TMACL)

#define TMAS                            5
#define TMAS_MSK                       (1 << TMAS)
#define TMAS_DMSCK                     (0 << TMAS)
#define TMAS_LPCCK                     (1 << TMAS)

#define DTMA                            2
#define DTMA_MSK                       (7 << DTMA)
#define DTMA_TMACKDIV2                 (0 << DTMA)
#define DTMA_TMACKDIV4                 (1 << DTMA)
#define DTMA_TMACKDIV8                 (2 << DTMA)
#define DTMA_TMACKDIV16                (3 << DTMA)
#define DTMA_TMACKDIV32                (4 << DTMA)
#define DTMA_TMACKDIV64                (5 << DTMA)
#define DTMA_TMACKDIV128               (6 << DTMA)
#define DTMA_TMACKDIV256               (7 << DTMA)

// TB1CN0 //
#define ENTB1                           7
#define ENTB1_MSK                      (1<<ENTB1)
#define ENTB1_ENABLE                   (1<<ENTB1)                           
#define ENTB1_DISABLE                  (0<<ENTB1)

#define TB1M                            5
#define TB1M_MSK                       (3<<TB1M)
#define TB1M_16bit                     (0<<TB1M)
#define TB1M_17bit                     (1<<TB1M)
#define TB1M_2_8bit                    (2<<TB1M)
#define TB1M_8_8bit                    (3<<TB1M)

#define TB1RT                           3
#define TB1RT_MSK                      (3<<TB1RT) 
#define TB1RT_LogicH                   (0<<TB1RT)
#define TB1RT_CP11                     (3<<TB1RT) 

#define TB1CL                           2
#define TB1CL_MSK                      (1<<TB1CL)
#define TB1CL_NORMAL                   (0<<TB1CL)
#define TB1CL_CLEAR                    (1<<TB1CL)

#define PWMO1                           1
#define PWMO1_MSK                      (1<<PWMO1)
#define PWMO1_DISABLE                  (0<<PWMO1)
#define PWMO1_OUTPUT                   (1<<PWMO1)

#define PWMO0                           0
#define PWMO0_MSK                      (1<<PWMO0)
#define PWMO0_DISABLE                  (0<<PWMO0)
#define PWMO0_OUTPUT                   (1<<PWMO0)

// TB1CN1 //
#define PA1IV                           7
#define PA1IV_MSK                      (1<<PA1IV)
#define PA1IV_INVER                    (0<<PA1IV)
#define PA1IV_NORMAL                   (1<<PA1IV)

#define PA0IV                           3
#define PA0IV_MSK                      (1<<PA0IV)
#define PA0IV_INVER                    (0<<PA0IV)
#define PA0IV_NORMAL                   (1<<PA0IV)

#define PWMA1                           4
#define PWMA1_MSK                      (7<<PWMA1)
//#define PWMA1_PWM7O                  (7<<PWMA1)
#define PWMA1_PWM7O                    (6<<PWMA1)
#define PWMA1_PWM6O                    (5<<PWMA1)
#define PWMA1_PWM5O                    (4<<PWMA1)
#define PWMA1_PWM4O                    (3<<PWMA1)
#define PWMA1_PWM3O                    (2<<PWMA1)
#define PWMA1_PWM2O                    (1<<PWMA1)
#define PWMA1_PWM1O                    (0<<PWMA1)

#define PWMA0                           0
#define PWMA0_MSK                      (7<<PWMA0)
//#define PWMA0_PWM7O                  (7<<PWMA0)
#define PWMA0_PWM7O                    (6<<PWMA0)
#define PWMA0_PWM6O                    (5<<PWMA0)
#define PWMA0_PWM5O                    (4<<PWMA0)
#define PWMA0_PWM4O                    (3<<PWMA0)
#define PWMA0_PWM3O                    (2<<PWMA0)
#define PWMA0_PWM2O                    (1<<PWMA0)
#define PWMA0_PWM1O                    (0<<PWMA0)

// TC1CN0 //
#define TC1S                            5
#define TC1S_MSK                       (3<<TC1S)
#define TC1S_TBI0                      (0<<TC1S) 
#define TC1S_TBI1                      (1<<TC1S)
#define TC1S_LSCK                      (2<<TC1S)
#define TC1S_OPC                       (3<<TC1S)


// TB2CN0 //
#define ENTB2                           7
#define ENTB2_MSK                      (1<<ENTB2)
#define ENTB2_ENABLE                   (1<<ENTB2)                           
#define ENTB2_DISABLE                  (0<<ENTB2)

#define TB2M                            5
#define TB2M_MSK                       (3<<TB2M)
#define TB2M_16bit                     (0<<TB2M)
#define TB2M_17bit                     (1<<TB2M)
#define TB2M_2_8bit                    (2<<TB2M)
#define TB2M_8_8bit                    (3<<TB2M)

#define TB2RT                           3
#define TB2RT_MSK                      (3<<TB2RT) 
#define TB2RT_LogicH                   (0<<TB2RT)
#define TB2RT_CP11                     (3<<TB2RT) 
                                             
#define TB2CL                           2    
#define TB2CL_MSK                      (1<<TB2CL)
#define TB2CL_NORMAL                   (0<<TB2CL)
#define TB2CL_CLEAR                    (1<<TB2CL)

#define PWMO3                           1
#define PWMO3_MSK                      (1<<PWMO3)
#define PWMO3_DISABLE                  (0<<PWMO3)
#define PWMO3_OUTPUT                   (1<<PWMO3)

#define PWMO2                           0
#define PWMO2_MSK                      (1<<PWMO2)
#define PWMO2_DISABLE                  (0<<PWMO2)
#define PWMO2_OUTPUT                   (1<<PWMO2)

// TB2CN1 //
#define PA3IV                           7
#define PA3IV_MSK                      (1<<PA3IV)
#define PA3IV_INVER                    (0<<PA3IV)
#define PA3IV_NORMAL                   (1<<PA3IV)

#define PA2IV                           3
#define PA2IV_MSK                      (1<<PA2IV)
#define PA2IV_INVER                    (0<<PA2IV)
#define PA2IV_NORMAL                   (1<<PA2IV)

#define PWMA3                           4
#define PWMA3_MSK                      (7<<PWMA3)
//#define PWMA3_PWM7O                  (7<<PWMA3)
#define PWMA3_PWM7O                    (6<<PWMA3)
#define PWMA3_PWM6O                    (5<<PWMA3)
#define PWMA3_PWM5O                    (4<<PWMA3)
#define PWMA3_PWM4O                    (3<<PWMA3)
#define PWMA3_PWM3O                    (2<<PWMA3)
#define PWMA3_PWM2O                    (1<<PWMA3)
#define PWMA3_PWM1O                    (0<<PWMA3)

#define PWMA2                           0
#define PWMA2_MSK                      (7<<PWMA2)
//#define PWMA2_PWM7O                  (7<<PWMA2)
#define PWMA2_PWM7O                    (6<<PWMA2)
#define PWMA2_PWM6O                    (5<<PWMA2)
#define PWMA2_PWM5O                    (4<<PWMA2)
#define PWMA2_PWM4O                    (3<<PWMA2)
#define PWMA2_PWM3O                    (2<<PWMA2)
#define PWMA2_PWM2O                    (1<<PWMA2)
#define PWMA2_PWM1O                    (0<<PWMA2)

// TC2CN0 //
#define TC2S                            5
#define TC2S_MSK                       (3<<TC2S)
#define TC2S_TBI0                      (0<<TC2S) 
#define TC2S_TBI1                      (1<<TC2S)
#define TC2S_LSCK                      (2<<TC2S)
#define TC2S_OPC                       (3<<TC2S)
/*-------------------------------------------------------------------------------------------------|
|  Function-like Macro:                                                                            |
|    Register Bits field Configuration without function call overhead,                             |
|    user should take care of detail of h/w behavior and constrains.                               |
|-------------------------------------------------------------------------------------------------*/
//CLK Config function for Peripherals were placed in each peripheral module individually
//CLK Config for MCU(System Clock)were declared/defined below

#define TMA1Enable()            (TMA1CN |= ENTMA_ENABLE)
#define TMA1Disable()           (TMA1CN &= ~(ENTMA_MSK))
#define TMA1ClearSet()          (TMA1CN |= TMACL_CLEAR)
#define TMA1_CLKSelect(Sel)     (TMA1CN =  (TMA1CN & (~TMAS_MSK)) | (Sel))
#define TMA1_CLKDiv(Sel)        (TMA1CN =  (TMA1CN & (~DTMA_MSK)) | (Sel))
#define TMA1_CompSet(Set)       (TMA1C=Set)
#define TMA1_ClearTMA1R()        (TMA1R=0)

#define TMA2Enable()            (TMA2CN |= ENTMA_ENABLE)
#define TMA2Disable()           (TMA2CN &= ~(ENTMA_MSK))
#define TMA2ClearSet()          (TMA2CN |= TMACL_CLEAR)
#define TMA2_CLKSelect(Sel)     (TMA2CN =  (TMA2CN & (~TMAS_MSK)) | (Sel))
#define TMA2_CLKDiv(Sel)        (TMA2CN =  (TMA2CN & (~DTMA_MSK)) | (Sel))
#define TMA2_CompSet(Set)       (TMA2C=Set)
#define TMA2_ClearTMA2R()        (TMA2R=0)


#define TB1Enable()             (TB1CN0 |= ENTB1_ENABLE)
#define TB1Disable()            (TB1CN0 &= ~(ENTB1_MSK))
#define TB1_ModeSelect(Sel)     (TB1CN0 =  (TB1CN0 & (~TB1M_MSK)) | (Sel))
#define TB1_TRIG_MODE(Sel)      (TB1CN0 =  (TB1CN0 & (~TB1RT_MSK)) | (Sel))
#define TB1_ClearTMB1()            (TB1CN0 |=  TB1CL_CLEAR )
#define TB1_PWMO1(Sel)          (TB1CN0 =  (TB1CN0 & (~PWMO1_MSK )) | (Sel)) 
#define TB1_PWMO0(Sel)          (TB1CN0 =  (TB1CN0 & (~PWMO0_MSK )) | (Sel))
#define TB1_CKSelect(TMBCKSel)         (OSCCN1 = ((OSCCN1 & (~TMBS_MSK)) | TMBCKSel))
#define TB1_CKDivSelect(TMBCKDivSel)   (OSCCN1 = ((OSCCN1 & (~DTMB_MSK)) | TMBCKDivSel))
//#define CLK_TMBCKSelect(TMBCKSel)         (OSCCN1 = ((OSCCN1 & (~TMBS_MSK)) | TMBCKSel))
//#define CLK_TMBCKDivSelect(TMBCKDivSel)   (OSCCN1 = ((OSCCN1 & (~DTMB_MSK)) | TMBCKDivSel))

#define TB1_PWM1ModeSelect(Sel)   (TB1CN1 =   (TB1CN1 &  (~PWMA1_MSK)) | (Sel))
#define TB1_PWM0ModeSelect(Sel)   (TB1CN1 =   (TB1CN1 &  (~PWMA0_MSK)) | (Sel))
#define TB1_PWM1_PHASE(Sel)     (TB1CN1 =   (TB1CN1 &  (~PA1IV_MSK)) | (Sel))
#define TB1_PWM0_PHASE(Sel)     (TB1CN1 =   (TB1CN1 &  (~PA0IV_MSK)) | (Sel))
#define TB1_TB1C0HSet(Set)     (TB1C0H =  Set)
#define TB1_TB1C0LSet(Set)     (TB1C0L =  Set)
#define TB1_TB1C1HSet(Set)     (TB1C1H =  Set)
#define TB1_TB1C1HSet(Set)     (TB1C1H =  Set)
#define TB1_TB1C2HSet(Set)     (TB1C2H =  Set)
#define TB1_TB1C2HSet(Set)     (TB1C2H =  Set)

#define TB1_TC1Select(Set)      (TC1CN0 = TC1CN0 &  (~TC1S_MSK)) | (Sel))


#define TB2Enable()             (TB2CN0 |= ENTB2_ENABLE)
#define TB2Disable()            (TB2CN0 &= ~(ENTB2_MSK))
#define TB2_ModeSelect(Sel)     (TB2CN0 =  (TB2CN0 & (~TB2M_MSK)) | (Sel))
#define TB2_TRIG_MODE(Sel)      (TB2CN0 =  (TB2CN0 & (~TB2RT_MSK)) | (Sel))
#define TB2_ClearTMB1()         (TB2CN0 |=  TB2CL_CLEAR )
#define TB2_PWMO2(Sel)          (TB2CN0 =  (TB2CN0 & (~PWMO2_MSK )) | (Sel)) 
#define TB2_PWMO3(Sel)          (TB2CN0 =  (TB2CN0 & (~PWMO3_MSK )) | (Sel))
#define TB2_CKSelect(TMB2CKSel)         (OSCCN3 = ((OSCCN3 & (~TMB2S_MSK)) | TMB2CKSel))
#define TB2_CKDivSelect(TMB2CKDivSel)   (OSCCN3 = ((OSCCN3 & (~DTMB2_MSK)) | TMB2CKDivSel))
//#define CLK_TMB2CKDivSelect(TMB2CKDivSel)   (OSCCN3 = ((OSCCN3 & (~DTMB2_MSK)) | TMB2CKDivSel))
//#define CLK_TMB2CKSelect(TMB2CKSel)         (OSCCN3 = ((OSCCN3 & (~TMB2S_MSK)) | TMB2CKSel))

#define TB2_PWM2ModeSelect(Sel)   (TB2CN1 =   (TB2CN1 &  (~PWMA2_MSK)) | (Sel))
#define TB2_PWM3ModeSelect(Sel)   (TB2CN1 =   (TB2CN1 &  (~PWMA3_MSK)) | (Sel))
#define TB2_PWM2_PHASE(Sel)     (TB2CN1 =   (TB2CN1 &  (~PA2IV_MSK)) | (Sel))
#define TB2_PWM3_PHASE(Sel)     (TB2CN1 =   (TB2CN1 &  (~PA3IV_MSK)) | (Sel))
#define TB2_TB2C0HSet(Set)     (TB2C0H =  Set)
#define TB2_TB2C0LSet(Set)     (TB2C0L =  Set)
#define TB2_TB2C1HSet(Set)     (TB2C1H =  Set)
#define TB2_TB2C1HSet(Set)     (TB2C1H =  Set)
#define TB2_TB2C2HSet(Set)     (TB2C2H =  Set)
#define TB2_TB2C2HSet(Set)     (TB2C2H =  Set)

#define TB2_TC2Select(Set)      (TC2CN0 = TC2CN0 &  (~TC2S_MSK)) | (Sel))


void TMA1_Open(unsigned char ck, unsigned char cks,unsigned char tma_cmp);
void TMA2_Open(unsigned char ck, unsigned char cks,unsigned char tma_cmp);
void TMB1_Open(unsigned char ck,
						  unsigned char cks,
						  unsigned char mode,
						  unsigned char trig_mode);
						  
void TB1C0Set(unsigned int TMB);
void TB1C1Set(unsigned int TMB);
void TB1C2Set(unsigned int TMB);

void TMB2_Open(unsigned char ck,
						  unsigned char cks,
						  unsigned char mode,
						  unsigned char trig_mode);
						  
void TB2C0Set(unsigned int TMB);
void TB2C1Set(unsigned int TMB);
void TB2C2Set(unsigned int TMB);